/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAccessibleSetValueEvent.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsAccessibleSetValueEventValue(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSAccessibleSetValueEventPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSAccessibleSetValueEventPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAccessibleSetValueEventPrototype* ptr = new (NotNull, JSC::allocateCell<JSAccessibleSetValueEventPrototype>(vm.heap)) JSAccessibleSetValueEventPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAccessibleSetValueEventPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSAccessibleSetValueEventPrototypeTableValues[] =
{
    { "value", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAccessibleSetValueEventValue), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSAccessibleSetValueEventPrototype::s_info = { "AccessibleSetValueEventPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAccessibleSetValueEventPrototype) };

void JSAccessibleSetValueEventPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAccessibleSetValueEvent::info(), JSAccessibleSetValueEventPrototypeTableValues, *this);
}

const ClassInfo JSAccessibleSetValueEvent::s_info = { "AccessibleSetValueEvent", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAccessibleSetValueEvent) };

JSAccessibleSetValueEvent::JSAccessibleSetValueEvent(Structure* structure, JSDOMGlobalObject& globalObject, Ref<AccessibleSetValueEvent>&& impl)
    : JSEvent(structure, globalObject, WTFMove(impl))
{
}

void JSAccessibleSetValueEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSAccessibleSetValueEvent::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSAccessibleSetValueEventPrototype::create(vm, &globalObject, JSAccessibleSetValueEventPrototype::createStructure(vm, &globalObject, JSEvent::prototype(vm, globalObject)));
}

JSObject* JSAccessibleSetValueEvent::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSAccessibleSetValueEvent>(vm, globalObject);
}

template<> inline JSAccessibleSetValueEvent* IDLAttribute<JSAccessibleSetValueEvent>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSAccessibleSetValueEvent*>(state.vm(), JSValue::decode(thisValue));
}

static inline JSValue jsAccessibleSetValueEventValueGetter(ExecState& state, JSAccessibleSetValueEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, throwScope, impl.value());
    return result;
}

EncodedJSValue jsAccessibleSetValueEventValue(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSAccessibleSetValueEvent>::get<jsAccessibleSetValueEventValueGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "value");
}

void JSAccessibleSetValueEvent::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSAccessibleSetValueEvent*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}


}
