/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAnimationEffect.h"

#include "JSComputedEffectTiming.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSEffectTiming.h"
#include "JSOptionalEffectTiming.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsAnimationEffectPrototypeFunctionGetTiming(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsAnimationEffectPrototypeFunctionGetComputedTiming(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsAnimationEffectPrototypeFunctionUpdateTiming(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsAnimationEffectConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSAnimationEffectConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSAnimationEffectPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSAnimationEffectPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAnimationEffectPrototype* ptr = new (NotNull, JSC::allocateCell<JSAnimationEffectPrototype>(vm.heap)) JSAnimationEffectPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAnimationEffectPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSAnimationEffectConstructor = JSDOMConstructorNotConstructable<JSAnimationEffect>;

template<> JSValue JSAnimationEffectConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSAnimationEffectConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSAnimationEffect::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("AnimationEffect"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSAnimationEffectConstructor::s_info = { "AnimationEffect", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectConstructor) };

/* Hash table for prototype */

static const HashTableValue JSAnimationEffectPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAnimationEffectConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAnimationEffectConstructor) } },
    { "getTiming", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsAnimationEffectPrototypeFunctionGetTiming), (intptr_t) (0) } },
    { "getComputedTiming", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsAnimationEffectPrototypeFunctionGetComputedTiming), (intptr_t) (0) } },
    { "updateTiming", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsAnimationEffectPrototypeFunctionUpdateTiming), (intptr_t) (0) } },
};

const ClassInfo JSAnimationEffectPrototype::s_info = { "AnimationEffectPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectPrototype) };

void JSAnimationEffectPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAnimationEffect::info(), JSAnimationEffectPrototypeTableValues, *this);
}

const ClassInfo JSAnimationEffect::s_info = { "AnimationEffect", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffect) };

JSAnimationEffect::JSAnimationEffect(Structure* structure, JSDOMGlobalObject& globalObject, Ref<AnimationEffect>&& impl)
    : JSDOMWrapper<AnimationEffect>(structure, globalObject, WTFMove(impl))
{
}

void JSAnimationEffect::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSAnimationEffect::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSAnimationEffectPrototype::create(vm, &globalObject, JSAnimationEffectPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSAnimationEffect::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSAnimationEffect>(vm, globalObject);
}

JSValue JSAnimationEffect::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAnimationEffectConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSAnimationEffect::destroy(JSC::JSCell* cell)
{
    JSAnimationEffect* thisObject = static_cast<JSAnimationEffect*>(cell);
    thisObject->JSAnimationEffect::~JSAnimationEffect();
}

template<> inline JSAnimationEffect* IDLOperation<JSAnimationEffect>::cast(ExecState& state)
{
    return jsDynamicCast<JSAnimationEffect*>(state.vm(), state.thisValue());
}

EncodedJSValue jsAnimationEffectConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSAnimationEffectPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSAnimationEffect::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSAnimationEffectConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSAnimationEffectPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsAnimationEffectPrototypeFunctionGetTimingBody(JSC::ExecState* state, typename IDLOperation<JSAnimationEffect>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLDictionary<EffectTiming>>(*state, *castedThis->globalObject(), impl.getTiming()));
}

EncodedJSValue JSC_HOST_CALL jsAnimationEffectPrototypeFunctionGetTiming(ExecState* state)
{
    return IDLOperation<JSAnimationEffect>::call<jsAnimationEffectPrototypeFunctionGetTimingBody>(*state, "getTiming");
}

static inline JSC::EncodedJSValue jsAnimationEffectPrototypeFunctionGetComputedTimingBody(JSC::ExecState* state, typename IDLOperation<JSAnimationEffect>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLDictionary<ComputedEffectTiming>>(*state, *castedThis->globalObject(), impl.getComputedTiming()));
}

EncodedJSValue JSC_HOST_CALL jsAnimationEffectPrototypeFunctionGetComputedTiming(ExecState* state)
{
    return IDLOperation<JSAnimationEffect>::call<jsAnimationEffectPrototypeFunctionGetComputedTimingBody>(*state, "getComputedTiming");
}

static inline JSC::EncodedJSValue jsAnimationEffectPrototypeFunctionUpdateTimingBody(JSC::ExecState* state, typename IDLOperation<JSAnimationEffect>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto timing = convert<IDLDictionary<OptionalEffectTiming>>(*state, state->argument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    propagateException(*state, throwScope, impl.updateTiming(WTFMove(timing)));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsAnimationEffectPrototypeFunctionUpdateTiming(ExecState* state)
{
    return IDLOperation<JSAnimationEffect>::call<jsAnimationEffectPrototypeFunctionUpdateTimingBody>(*state, "updateTiming");
}

void JSAnimationEffect::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSAnimationEffect*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSAnimationEffectOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSAnimationEffectOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsAnimationEffect = static_cast<JSAnimationEffect*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsAnimationEffect->wrapped(), jsAnimationEffect);
}

AnimationEffect* JSAnimationEffect::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSAnimationEffect*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
