/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAnimationTimeline.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsAnimationTimelineConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSAnimationTimelineConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsAnimationTimelineCurrentTime(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSAnimationTimelinePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSAnimationTimelinePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAnimationTimelinePrototype* ptr = new (NotNull, JSC::allocateCell<JSAnimationTimelinePrototype>(vm.heap)) JSAnimationTimelinePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAnimationTimelinePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSAnimationTimelineConstructor = JSDOMConstructorNotConstructable<JSAnimationTimeline>;

template<> JSValue JSAnimationTimelineConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSAnimationTimelineConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSAnimationTimeline::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("AnimationTimeline"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSAnimationTimelineConstructor::s_info = { "AnimationTimeline", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationTimelineConstructor) };

/* Hash table for prototype */

static const HashTableValue JSAnimationTimelinePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAnimationTimelineConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAnimationTimelineConstructor) } },
    { "currentTime", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAnimationTimelineCurrentTime), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSAnimationTimelinePrototype::s_info = { "AnimationTimelinePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationTimelinePrototype) };

void JSAnimationTimelinePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAnimationTimeline::info(), JSAnimationTimelinePrototypeTableValues, *this);
}

const ClassInfo JSAnimationTimeline::s_info = { "AnimationTimeline", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationTimeline) };

JSAnimationTimeline::JSAnimationTimeline(Structure* structure, JSDOMGlobalObject& globalObject, Ref<AnimationTimeline>&& impl)
    : JSDOMWrapper<AnimationTimeline>(structure, globalObject, WTFMove(impl))
{
}

void JSAnimationTimeline::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSAnimationTimeline::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSAnimationTimelinePrototype::create(vm, &globalObject, JSAnimationTimelinePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSAnimationTimeline::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSAnimationTimeline>(vm, globalObject);
}

JSValue JSAnimationTimeline::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAnimationTimelineConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSAnimationTimeline::destroy(JSC::JSCell* cell)
{
    JSAnimationTimeline* thisObject = static_cast<JSAnimationTimeline*>(cell);
    thisObject->JSAnimationTimeline::~JSAnimationTimeline();
}

template<> inline JSAnimationTimeline* IDLAttribute<JSAnimationTimeline>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSAnimationTimeline*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsAnimationTimelineConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSAnimationTimelinePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSAnimationTimeline::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSAnimationTimelineConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSAnimationTimelinePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsAnimationTimelineCurrentTimeGetter(ExecState& state, JSAnimationTimeline& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLDouble>>(state, throwScope, impl.bindingsCurrentTime());
    return result;
}

EncodedJSValue jsAnimationTimelineCurrentTime(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSAnimationTimeline>::get<jsAnimationTimelineCurrentTimeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "currentTime");
}

void JSAnimationTimeline::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSAnimationTimeline*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSAnimationTimelineOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSAnimationTimelineOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsAnimationTimeline = static_cast<JSAnimationTimeline*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsAnimationTimeline->wrapped(), jsAnimationTimeline);
}

AnimationTimeline* JSAnimationTimeline::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSAnimationTimeline*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
