/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCacheQueryOptions.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertStrings.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> CacheQueryOptions convertDictionary<CacheQueryOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CacheQueryOptions result;
    JSValue cacheNameValue;
    if (isNullOrUndefined)
        cacheNameValue = jsUndefined();
    else {
        cacheNameValue = object->get(&state, Identifier::fromString(&state, "cacheName"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!cacheNameValue.isUndefined()) {
        result.cacheName = convert<IDLDOMString>(state, cacheNameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue ignoreMethodValue;
    if (isNullOrUndefined)
        ignoreMethodValue = jsUndefined();
    else {
        ignoreMethodValue = object->get(&state, Identifier::fromString(&state, "ignoreMethod"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!ignoreMethodValue.isUndefined()) {
        result.ignoreMethod = convert<IDLBoolean>(state, ignoreMethodValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.ignoreMethod = false;
    JSValue ignoreSearchValue;
    if (isNullOrUndefined)
        ignoreSearchValue = jsUndefined();
    else {
        ignoreSearchValue = object->get(&state, Identifier::fromString(&state, "ignoreSearch"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!ignoreSearchValue.isUndefined()) {
        result.ignoreSearch = convert<IDLBoolean>(state, ignoreSearchValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.ignoreSearch = false;
    JSValue ignoreVaryValue;
    if (isNullOrUndefined)
        ignoreVaryValue = jsUndefined();
    else {
        ignoreVaryValue = object->get(&state, Identifier::fromString(&state, "ignoreVary"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!ignoreVaryValue.isUndefined()) {
        result.ignoreVary = convert<IDLBoolean>(state, ignoreVaryValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.ignoreVary = false;
    return result;
}

} // namespace WebCore
