/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSComputedEffectTiming.h"

#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMGlobalObject.h"
#include "JSFillMode.h"
#include "JSPlaybackDirection.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

template<> ComputedEffectTiming convertDictionary<ComputedEffectTiming>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    ComputedEffectTiming result;
    JSValue delayValue;
    if (isNullOrUndefined)
        delayValue = jsUndefined();
    else {
        delayValue = object->get(&state, Identifier::fromString(&state, "delay"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!delayValue.isUndefined()) {
        result.delay = convert<IDLDouble>(state, delayValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.delay = 0;
    JSValue directionValue;
    if (isNullOrUndefined)
        directionValue = jsUndefined();
    else {
        directionValue = object->get(&state, Identifier::fromString(&state, "direction"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!directionValue.isUndefined()) {
        result.direction = convert<IDLEnumeration<PlaybackDirection>>(state, directionValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.direction = PlaybackDirection::Normal;
    JSValue durationValue;
    if (isNullOrUndefined)
        durationValue = jsUndefined();
    else {
        durationValue = object->get(&state, Identifier::fromString(&state, "duration"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!durationValue.isUndefined()) {
        result.duration = convert<IDLUnion<IDLUnrestrictedDouble, IDLDOMString>>(state, durationValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.duration = "auto";
    JSValue easingValue;
    if (isNullOrUndefined)
        easingValue = jsUndefined();
    else {
        easingValue = object->get(&state, Identifier::fromString(&state, "easing"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!easingValue.isUndefined()) {
        result.easing = convert<IDLDOMString>(state, easingValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.easing = "linear"_s;
    JSValue endDelayValue;
    if (isNullOrUndefined)
        endDelayValue = jsUndefined();
    else {
        endDelayValue = object->get(&state, Identifier::fromString(&state, "endDelay"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!endDelayValue.isUndefined()) {
        result.endDelay = convert<IDLDouble>(state, endDelayValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.endDelay = 0;
    JSValue fillValue;
    if (isNullOrUndefined)
        fillValue = jsUndefined();
    else {
        fillValue = object->get(&state, Identifier::fromString(&state, "fill"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!fillValue.isUndefined()) {
        result.fill = convert<IDLEnumeration<FillMode>>(state, fillValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.fill = FillMode::Auto;
    JSValue iterationStartValue;
    if (isNullOrUndefined)
        iterationStartValue = jsUndefined();
    else {
        iterationStartValue = object->get(&state, Identifier::fromString(&state, "iterationStart"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!iterationStartValue.isUndefined()) {
        result.iterationStart = convert<IDLDouble>(state, iterationStartValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.iterationStart = 0.0;
    JSValue iterationsValue;
    if (isNullOrUndefined)
        iterationsValue = jsUndefined();
    else {
        iterationsValue = object->get(&state, Identifier::fromString(&state, "iterations"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!iterationsValue.isUndefined()) {
        result.iterations = convert<IDLUnrestrictedDouble>(state, iterationsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.iterations = 1.0;
    JSValue activeDurationValue;
    if (isNullOrUndefined)
        activeDurationValue = jsUndefined();
    else {
        activeDurationValue = object->get(&state, Identifier::fromString(&state, "activeDuration"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!activeDurationValue.isUndefined()) {
        result.activeDuration = convert<IDLUnrestrictedDouble>(state, activeDurationValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue currentIterationValue;
    if (isNullOrUndefined)
        currentIterationValue = jsUndefined();
    else {
        currentIterationValue = object->get(&state, Identifier::fromString(&state, "currentIteration"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!currentIterationValue.isUndefined()) {
        result.currentIteration = convert<IDLNullable<IDLUnrestrictedDouble>>(state, currentIterationValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.currentIteration = WTF::nullopt;
    JSValue endTimeValue;
    if (isNullOrUndefined)
        endTimeValue = jsUndefined();
    else {
        endTimeValue = object->get(&state, Identifier::fromString(&state, "endTime"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!endTimeValue.isUndefined()) {
        result.endTime = convert<IDLUnrestrictedDouble>(state, endTimeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue localTimeValue;
    if (isNullOrUndefined)
        localTimeValue = jsUndefined();
    else {
        localTimeValue = object->get(&state, Identifier::fromString(&state, "localTime"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!localTimeValue.isUndefined()) {
        result.localTime = convert<IDLNullable<IDLDouble>>(state, localTimeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.localTime = WTF::nullopt;
    JSValue progressValue;
    if (isNullOrUndefined)
        progressValue = jsUndefined();
    else {
        progressValue = object->get(&state, Identifier::fromString(&state, "progress"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!progressValue.isUndefined()) {
        result.progress = convert<IDLNullable<IDLDouble>>(state, progressValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.progress = WTF::nullopt;
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const ComputedEffectTiming& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto delayValue = toJS<IDLDouble>(dictionary.delay);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "delay"), delayValue);
    auto directionValue = toJS<IDLEnumeration<PlaybackDirection>>(state, dictionary.direction);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "direction"), directionValue);
    auto durationValue = toJS<IDLUnion<IDLUnrestrictedDouble, IDLDOMString>>(state, globalObject, dictionary.duration);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "duration"), durationValue);
    auto easingValue = toJS<IDLDOMString>(state, dictionary.easing);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "easing"), easingValue);
    auto endDelayValue = toJS<IDLDouble>(dictionary.endDelay);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "endDelay"), endDelayValue);
    auto fillValue = toJS<IDLEnumeration<FillMode>>(state, dictionary.fill);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "fill"), fillValue);
    auto iterationStartValue = toJS<IDLDouble>(dictionary.iterationStart);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "iterationStart"), iterationStartValue);
    auto iterationsValue = toJS<IDLUnrestrictedDouble>(dictionary.iterations);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "iterations"), iterationsValue);
    if (!IDLUnrestrictedDouble::isNullValue(dictionary.activeDuration)) {
        auto activeDurationValue = toJS<IDLUnrestrictedDouble>(IDLUnrestrictedDouble::extractValueFromNullable(dictionary.activeDuration));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "activeDuration"), activeDurationValue);
    }
    auto currentIterationValue = toJS<IDLNullable<IDLUnrestrictedDouble>>(dictionary.currentIteration);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "currentIteration"), currentIterationValue);
    if (!IDLUnrestrictedDouble::isNullValue(dictionary.endTime)) {
        auto endTimeValue = toJS<IDLUnrestrictedDouble>(IDLUnrestrictedDouble::extractValueFromNullable(dictionary.endTime));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "endTime"), endTimeValue);
    }
    auto localTimeValue = toJS<IDLNullable<IDLDouble>>(dictionary.localTime);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "localTime"), localTimeValue);
    auto progressValue = toJS<IDLNullable<IDLDouble>>(dictionary.progress);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "progress"), progressValue);
    return result;
}

} // namespace WebCore
