/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_CRYPTO)

#include "JSCryptoKeyPair.h"

#include "JSCryptoKey.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(WEB_CRYPTO)

template<> CryptoKeyPair convertDictionary<CryptoKeyPair>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CryptoKeyPair result;
    JSValue privateKeyValue;
    if (isNullOrUndefined)
        privateKeyValue = jsUndefined();
    else {
        privateKeyValue = object->get(&state, Identifier::fromString(&state, "privateKey"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!privateKeyValue.isUndefined()) {
        result.privateKey = convert<IDLInterface<CryptoKey>>(state, privateKeyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue publicKeyValue;
    if (isNullOrUndefined)
        publicKeyValue = jsUndefined();
    else {
        publicKeyValue = object->get(&state, Identifier::fromString(&state, "publicKey"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!publicKeyValue.isUndefined()) {
        result.publicKey = convert<IDLInterface<CryptoKey>>(state, publicKeyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const CryptoKeyPair& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    if (!IDLInterface<CryptoKey>::isNullValue(dictionary.privateKey)) {
        auto privateKeyValue = toJS<IDLInterface<CryptoKey>>(state, globalObject, IDLInterface<CryptoKey>::extractValueFromNullable(dictionary.privateKey));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "privateKey"), privateKeyValue);
    }
    if (!IDLInterface<CryptoKey>::isNullValue(dictionary.publicKey)) {
        auto publicKeyValue = toJS<IDLInterface<CryptoKey>>(state, globalObject, IDLInterface<CryptoKey>::extractValueFromNullable(dictionary.publicKey));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "publicKey"), publicKeyValue);
    }
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(WEB_CRYPTO)
