/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCustomElementRegistry.h"

#include "CustomElementReactionQueue.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertAny.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSNode.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionDefine(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionGet(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionWhenDefined(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionUpgrade(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsCustomElementRegistryConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSCustomElementRegistryConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSCustomElementRegistryPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCustomElementRegistryPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCustomElementRegistryPrototype* ptr = new (NotNull, JSC::allocateCell<JSCustomElementRegistryPrototype>(vm.heap)) JSCustomElementRegistryPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCustomElementRegistryPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSCustomElementRegistryConstructor = JSDOMConstructorNotConstructable<JSCustomElementRegistry>;

template<> JSValue JSCustomElementRegistryConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCustomElementRegistryConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSCustomElementRegistry::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("CustomElementRegistry"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSCustomElementRegistryConstructor::s_info = { "CustomElementRegistry", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCustomElementRegistryConstructor) };

/* Hash table for prototype */

static const HashTableValue JSCustomElementRegistryPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCustomElementRegistryConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCustomElementRegistryConstructor) } },
    { "define", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunctionDefine), (intptr_t) (2) } },
    { "get", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunctionGet), (intptr_t) (1) } },
    { "whenDefined", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunctionWhenDefined), (intptr_t) (1) } },
    { "upgrade", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsCustomElementRegistryPrototypeFunctionUpgrade), (intptr_t) (1) } },
};

const ClassInfo JSCustomElementRegistryPrototype::s_info = { "CustomElementRegistryPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCustomElementRegistryPrototype) };

void JSCustomElementRegistryPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCustomElementRegistry::info(), JSCustomElementRegistryPrototypeTableValues, *this);
}

const ClassInfo JSCustomElementRegistry::s_info = { "CustomElementRegistry", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCustomElementRegistry) };

JSCustomElementRegistry::JSCustomElementRegistry(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CustomElementRegistry>&& impl)
    : JSDOMWrapper<CustomElementRegistry>(structure, globalObject, WTFMove(impl))
{
}

void JSCustomElementRegistry::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCustomElementRegistry::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCustomElementRegistryPrototype::create(vm, &globalObject, JSCustomElementRegistryPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCustomElementRegistry::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCustomElementRegistry>(vm, globalObject);
}

JSValue JSCustomElementRegistry::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCustomElementRegistryConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSCustomElementRegistry::destroy(JSC::JSCell* cell)
{
    JSCustomElementRegistry* thisObject = static_cast<JSCustomElementRegistry*>(cell);
    thisObject->JSCustomElementRegistry::~JSCustomElementRegistry();
}

template<> inline JSCustomElementRegistry* IDLOperation<JSCustomElementRegistry>::cast(ExecState& state)
{
    return jsDynamicCast<JSCustomElementRegistry*>(state.vm(), state.thisValue());
}

EncodedJSValue jsCustomElementRegistryConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSCustomElementRegistryPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSCustomElementRegistry::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSCustomElementRegistryConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSCustomElementRegistryPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunctionDefineBody(JSC::ExecState* state, typename IDLOperation<JSCustomElementRegistry>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    CustomElementReactionStack customElementReactionStack(*state);
    return JSValue::encode(castedThis->define(*state));
}

EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionDefine(ExecState* state)
{
    return IDLOperation<JSCustomElementRegistry>::call<jsCustomElementRegistryPrototypeFunctionDefineBody>(*state, "define");
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunctionGetBody(JSC::ExecState* state, typename IDLOperation<JSCustomElementRegistry>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto name = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLAny>(impl.get(WTFMove(name))));
}

EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionGet(ExecState* state)
{
    return IDLOperation<JSCustomElementRegistry>::call<jsCustomElementRegistryPrototypeFunctionGetBody>(*state, "get");
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunctionWhenDefinedBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCustomElementRegistry>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    return JSValue::encode(castedThis->whenDefined(*state));
}

EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionWhenDefined(ExecState* state)
{
    return IDLOperationReturningPromise<JSCustomElementRegistry>::callReturningOwnPromise<jsCustomElementRegistryPrototypeFunctionWhenDefinedBody>(*state, "whenDefined");
}

static inline JSC::EncodedJSValue jsCustomElementRegistryPrototypeFunctionUpgradeBody(JSC::ExecState* state, typename IDLOperation<JSCustomElementRegistry>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    CustomElementReactionStack customElementReactionStack(*state);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto root = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "root", "CustomElementRegistry", "upgrade", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.upgrade(*root);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCustomElementRegistryPrototypeFunctionUpgrade(ExecState* state)
{
    return IDLOperation<JSCustomElementRegistry>::call<jsCustomElementRegistryPrototypeFunctionUpgradeBody>(*state, "upgrade");
}

void JSCustomElementRegistry::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSCustomElementRegistry*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSCustomElementRegistryOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    auto* jsCustomElementRegistry = jsCast<JSCustomElementRegistry*>(handle.slot()->asCell());
    ScriptExecutionContext* root = WTF::getPtr(jsCustomElementRegistry->wrapped().scriptExecutionContext());
    if (!root)
        return false;
    if (UNLIKELY(reason))
        *reason = "Reachable from ScriptExecutionContext";
    return root && visitor.containsOpaqueRoot(root);
}

void JSCustomElementRegistryOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCustomElementRegistry = static_cast<JSCustomElementRegistry*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCustomElementRegistry->wrapped(), jsCustomElementRegistry);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7CustomElementRegistry@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore21CustomElementRegistryE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<CustomElementRegistry>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(__identifier("??_7CustomElementRegistry@WebCore@@6B@"));
#else
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(&_ZTVN7WebCore21CustomElementRegistryE[2]);
#endif

    // If this fails CustomElementRegistry does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<CustomElementRegistry>::value, "CustomElementRegistry is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // CustomElementRegistry has subclasses. If CustomElementRegistry has subclasses that get passed
    // to toJS() we currently require CustomElementRegistry you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<CustomElementRegistry>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, CustomElementRegistry& impl)
{
    return wrap(state, globalObject, impl);
}

CustomElementRegistry* JSCustomElementRegistry::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSCustomElementRegistry*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
