/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#include "CustomElementRegistry.h"
#include "JSDOMWrapper.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSCustomElementRegistry : public JSDOMWrapper<CustomElementRegistry> {
public:
    using Base = JSDOMWrapper<CustomElementRegistry>;
    static JSCustomElementRegistry* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<CustomElementRegistry>&& impl)
    {
        JSCustomElementRegistry* ptr = new (NotNull, JSC::allocateCell<JSCustomElementRegistry>(globalObject->vm().heap)) JSCustomElementRegistry(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static CustomElementRegistry* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void heapSnapshot(JSCell*, JSC::HeapSnapshotBuilder&);

    // Custom functions
    JSC::JSValue define(JSC::ExecState&);
    JSC::JSValue whenDefined(JSC::ExecState&);
protected:
    JSCustomElementRegistry(JSC::Structure*, JSDOMGlobalObject&, Ref<CustomElementRegistry>&&);

    void finishCreation(JSC::VM&);
};

class JSCustomElementRegistryOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&, const char**);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, CustomElementRegistry*)
{
    static NeverDestroyed<JSCustomElementRegistryOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(CustomElementRegistry* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, CustomElementRegistry&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, CustomElementRegistry* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<CustomElementRegistry>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<CustomElementRegistry>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<CustomElementRegistry> {
    using WrapperClass = JSCustomElementRegistry;
    using ToWrappedReturnType = CustomElementRegistry*;
};

} // namespace WebCore
