/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSDOMCSSCustomPropertyDescriptor.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> DOMCSSCustomPropertyDescriptor convertDictionary<DOMCSSCustomPropertyDescriptor>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    DOMCSSCustomPropertyDescriptor result;
    JSValue inheritsValue;
    if (isNullOrUndefined)
        inheritsValue = jsUndefined();
    else {
        inheritsValue = object->get(&state, Identifier::fromString(&state, "inherits"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!inheritsValue.isUndefined()) {
        result.inherits = convert<IDLBoolean>(state, inheritsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "inherits", "DOMCSSCustomPropertyDescriptor", "boolean");
        return { };
    }
    JSValue initialValueValue;
    if (isNullOrUndefined)
        initialValueValue = jsUndefined();
    else {
        initialValueValue = object->get(&state, Identifier::fromString(&state, "initialValue"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!initialValueValue.isUndefined()) {
        result.initialValue = convert<IDLDOMString>(state, initialValueValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue nameValue;
    if (isNullOrUndefined)
        nameValue = jsUndefined();
    else {
        nameValue = object->get(&state, Identifier::fromString(&state, "name"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "name", "DOMCSSCustomPropertyDescriptor", "DOMString");
        return { };
    }
    JSValue syntaxValue;
    if (isNullOrUndefined)
        syntaxValue = jsUndefined();
    else {
        syntaxValue = object->get(&state, Identifier::fromString(&state, "syntax"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!syntaxValue.isUndefined()) {
        result.syntax = convert<IDLDOMString>(state, syntaxValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.syntax = "*"_s;
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const DOMCSSCustomPropertyDescriptor& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto inheritsValue = toJS<IDLBoolean>(dictionary.inherits);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "inherits"), inheritsValue);
    if (!IDLDOMString::isNullValue(dictionary.initialValue)) {
        auto initialValueValue = toJS<IDLDOMString>(state, IDLDOMString::extractValueFromNullable(dictionary.initialValue));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "initialValue"), initialValueValue);
    }
    auto nameValue = toJS<IDLDOMString>(state, dictionary.name);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "name"), nameValue);
    auto syntaxValue = toJS<IDLDOMString>(state, dictionary.syntax);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "syntax"), syntaxValue);
    return result;
}

} // namespace WebCore
