/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSDOMCacheStorage.h"

#include "JSCacheQueryOptions.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSFetchRequest.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionMatch(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionHas(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionOpen(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionDelete(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionKeys(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsDOMCacheStorageConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSDOMCacheStorageConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSDOMCacheStoragePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSDOMCacheStoragePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSDOMCacheStoragePrototype* ptr = new (NotNull, JSC::allocateCell<JSDOMCacheStoragePrototype>(vm.heap)) JSDOMCacheStoragePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSDOMCacheStoragePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSDOMCacheStorageConstructor = JSDOMConstructorNotConstructable<JSDOMCacheStorage>;

template<> JSValue JSDOMCacheStorageConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSDOMCacheStorageConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSDOMCacheStorage::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("CacheStorage"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSDOMCacheStorageConstructor::s_info = { "CacheStorage", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSDOMCacheStorageConstructor) };

/* Hash table for prototype */

static const HashTableValue JSDOMCacheStoragePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMCacheStorageConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSDOMCacheStorageConstructor) } },
    { "match", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsDOMCacheStoragePrototypeFunctionMatch), (intptr_t) (1) } },
    { "has", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsDOMCacheStoragePrototypeFunctionHas), (intptr_t) (1) } },
    { "open", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsDOMCacheStoragePrototypeFunctionOpen), (intptr_t) (1) } },
    { "delete", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsDOMCacheStoragePrototypeFunctionDelete), (intptr_t) (1) } },
    { "keys", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsDOMCacheStoragePrototypeFunctionKeys), (intptr_t) (0) } },
};

const ClassInfo JSDOMCacheStoragePrototype::s_info = { "CacheStoragePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSDOMCacheStoragePrototype) };

void JSDOMCacheStoragePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSDOMCacheStorage::info(), JSDOMCacheStoragePrototypeTableValues, *this);
}

const ClassInfo JSDOMCacheStorage::s_info = { "CacheStorage", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSDOMCacheStorage) };

JSDOMCacheStorage::JSDOMCacheStorage(Structure* structure, JSDOMGlobalObject& globalObject, Ref<DOMCacheStorage>&& impl)
    : JSDOMWrapper<DOMCacheStorage>(structure, globalObject, WTFMove(impl))
{
}

void JSDOMCacheStorage::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSDOMCacheStorage::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSDOMCacheStoragePrototype::create(vm, &globalObject, JSDOMCacheStoragePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSDOMCacheStorage::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSDOMCacheStorage>(vm, globalObject);
}

JSValue JSDOMCacheStorage::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSDOMCacheStorageConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSDOMCacheStorage::destroy(JSC::JSCell* cell)
{
    JSDOMCacheStorage* thisObject = static_cast<JSDOMCacheStorage*>(cell);
    thisObject->JSDOMCacheStorage::~JSDOMCacheStorage();
}

template<> inline JSDOMCacheStorage* IDLOperation<JSDOMCacheStorage>::cast(ExecState& state)
{
    return jsDynamicCast<JSDOMCacheStorage*>(state.vm(), state.thisValue());
}

EncodedJSValue jsDOMCacheStorageConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSDOMCacheStoragePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSDOMCacheStorage::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSDOMCacheStorageConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSDOMCacheStoragePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsDOMCacheStoragePrototypeFunctionMatchBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSDOMCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto request = convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto options = convert<IDLDictionary<CacheQueryOptions>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.match(WTFMove(request), WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionMatch(ExecState* state)
{
    return IDLOperationReturningPromise<JSDOMCacheStorage>::call<jsDOMCacheStoragePrototypeFunctionMatchBody, PromiseExecutionScope::WindowOrWorker>(*state, "match");
}

static inline JSC::EncodedJSValue jsDOMCacheStoragePrototypeFunctionHasBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSDOMCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto cacheName = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.has(WTFMove(cacheName), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionHas(ExecState* state)
{
    return IDLOperationReturningPromise<JSDOMCacheStorage>::call<jsDOMCacheStoragePrototypeFunctionHasBody, PromiseExecutionScope::WindowOrWorker>(*state, "has");
}

static inline JSC::EncodedJSValue jsDOMCacheStoragePrototypeFunctionOpenBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSDOMCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto cacheName = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.open(WTFMove(cacheName), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionOpen(ExecState* state)
{
    return IDLOperationReturningPromise<JSDOMCacheStorage>::call<jsDOMCacheStoragePrototypeFunctionOpenBody, PromiseExecutionScope::WindowOrWorker>(*state, "open");
}

static inline JSC::EncodedJSValue jsDOMCacheStoragePrototypeFunctionDeleteBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSDOMCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto cacheName = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.remove(WTFMove(cacheName), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionDelete(ExecState* state)
{
    return IDLOperationReturningPromise<JSDOMCacheStorage>::call<jsDOMCacheStoragePrototypeFunctionDeleteBody, PromiseExecutionScope::WindowOrWorker>(*state, "delete");
}

static inline JSC::EncodedJSValue jsDOMCacheStoragePrototypeFunctionKeysBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSDOMCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.keys(WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsDOMCacheStoragePrototypeFunctionKeys(ExecState* state)
{
    return IDLOperationReturningPromise<JSDOMCacheStorage>::call<jsDOMCacheStoragePrototypeFunctionKeysBody, PromiseExecutionScope::WindowOrWorker>(*state, "keys");
}

void JSDOMCacheStorage::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSDOMCacheStorage*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSDOMCacheStorageOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSDOMCacheStorageOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsDOMCacheStorage = static_cast<JSDOMCacheStorage*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsDOMCacheStorage->wrapped(), jsDOMCacheStorage);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7DOMCacheStorage@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15DOMCacheStorageE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<DOMCacheStorage>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(__identifier("??_7DOMCacheStorage@WebCore@@6B@"));
#else
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(&_ZTVN7WebCore15DOMCacheStorageE[2]);
#endif

    // If this fails DOMCacheStorage does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<DOMCacheStorage>::value, "DOMCacheStorage is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // DOMCacheStorage has subclasses. If DOMCacheStorage has subclasses that get passed
    // to toJS() we currently require DOMCacheStorage you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<DOMCacheStorage>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, DOMCacheStorage& impl)
{
    return wrap(state, globalObject, impl);
}

DOMCacheStorage* JSDOMCacheStorage::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSDOMCacheStorage*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
