/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSFileSystemEntry.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertCallbacks.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMFileSystem.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSErrorCallback.h"
#include "JSFileSystemEntryCallback.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsFileSystemEntryPrototypeFunctionGetParent(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsFileSystemEntryConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSFileSystemEntryConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsFileSystemEntryIsFile(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFileSystemEntryIsDirectory(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFileSystemEntryName(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFileSystemEntryFullPath(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFileSystemEntryFilesystem(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSFileSystemEntryPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSFileSystemEntryPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSFileSystemEntryPrototype* ptr = new (NotNull, JSC::allocateCell<JSFileSystemEntryPrototype>(vm.heap)) JSFileSystemEntryPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSFileSystemEntryPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSFileSystemEntryConstructor = JSDOMConstructorNotConstructable<JSFileSystemEntry>;

template<> JSValue JSFileSystemEntryConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSFileSystemEntryConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSFileSystemEntry::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("FileSystemEntry"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSFileSystemEntryConstructor::s_info = { "FileSystemEntry", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFileSystemEntryConstructor) };

/* Hash table for prototype */

static const HashTableValue JSFileSystemEntryPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFileSystemEntryConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSFileSystemEntryConstructor) } },
    { "isFile", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFileSystemEntryIsFile), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "isDirectory", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFileSystemEntryIsDirectory), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "name", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFileSystemEntryName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "fullPath", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFileSystemEntryFullPath), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "filesystem", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFileSystemEntryFilesystem), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "getParent", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsFileSystemEntryPrototypeFunctionGetParent), (intptr_t) (0) } },
};

const ClassInfo JSFileSystemEntryPrototype::s_info = { "FileSystemEntryPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFileSystemEntryPrototype) };

void JSFileSystemEntryPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSFileSystemEntry::info(), JSFileSystemEntryPrototypeTableValues, *this);
}

const ClassInfo JSFileSystemEntry::s_info = { "FileSystemEntry", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFileSystemEntry) };

JSFileSystemEntry::JSFileSystemEntry(Structure* structure, JSDOMGlobalObject& globalObject, Ref<FileSystemEntry>&& impl)
    : JSDOMWrapper<FileSystemEntry>(structure, globalObject, WTFMove(impl))
{
}

void JSFileSystemEntry::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSFileSystemEntry::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSFileSystemEntryPrototype::create(vm, &globalObject, JSFileSystemEntryPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSFileSystemEntry::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSFileSystemEntry>(vm, globalObject);
}

JSValue JSFileSystemEntry::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSFileSystemEntryConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSFileSystemEntry::destroy(JSC::JSCell* cell)
{
    JSFileSystemEntry* thisObject = static_cast<JSFileSystemEntry*>(cell);
    thisObject->JSFileSystemEntry::~JSFileSystemEntry();
}

template<> inline JSFileSystemEntry* IDLAttribute<JSFileSystemEntry>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSFileSystemEntry*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSFileSystemEntry* IDLOperation<JSFileSystemEntry>::cast(ExecState& state)
{
    return jsDynamicCast<JSFileSystemEntry*>(state.vm(), state.thisValue());
}

EncodedJSValue jsFileSystemEntryConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSFileSystemEntryPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSFileSystemEntry::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSFileSystemEntryConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSFileSystemEntryPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsFileSystemEntryIsFileGetter(ExecState& state, JSFileSystemEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.isFile());
    return result;
}

EncodedJSValue jsFileSystemEntryIsFile(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFileSystemEntry>::get<jsFileSystemEntryIsFileGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "isFile");
}

static inline JSValue jsFileSystemEntryIsDirectoryGetter(ExecState& state, JSFileSystemEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.isDirectory());
    return result;
}

EncodedJSValue jsFileSystemEntryIsDirectory(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFileSystemEntry>::get<jsFileSystemEntryIsDirectoryGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "isDirectory");
}

static inline JSValue jsFileSystemEntryNameGetter(ExecState& state, JSFileSystemEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, throwScope, impl.name());
    return result;
}

EncodedJSValue jsFileSystemEntryName(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFileSystemEntry>::get<jsFileSystemEntryNameGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "name");
}

static inline JSValue jsFileSystemEntryFullPathGetter(ExecState& state, JSFileSystemEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, throwScope, impl.virtualPath());
    return result;
}

EncodedJSValue jsFileSystemEntryFullPath(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFileSystemEntry>::get<jsFileSystemEntryFullPathGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "fullPath");
}

static inline JSValue jsFileSystemEntryFilesystemGetter(ExecState& state, JSFileSystemEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DOMFileSystem>>(state, *thisObject.globalObject(), throwScope, impl.filesystem());
    return result;
}

EncodedJSValue jsFileSystemEntryFilesystem(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFileSystemEntry>::get<jsFileSystemEntryFilesystemGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "filesystem");
}

static inline JSC::EncodedJSValue jsFileSystemEntryPrototypeFunctionGetParentBody(JSC::ExecState* state, typename IDLOperation<JSFileSystemEntry>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto* context = jsCast<JSDOMGlobalObject*>(state->lexicalGlobalObject())->scriptExecutionContext();
    if (UNLIKELY(!context))
        return JSValue::encode(jsUndefined());
    auto successCallback = convert<IDLNullable<IDLCallbackFunction<JSFileSystemEntryCallback>>>(*state, state->argument(0), *castedThis->globalObject(), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(state, scope, 0, "successCallback", "FileSystemEntry", "getParent"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto errorCallback = convert<IDLNullable<IDLCallbackFunction<JSErrorCallback>>>(*state, state->argument(1), *castedThis->globalObject(), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(state, scope, 1, "errorCallback", "FileSystemEntry", "getParent"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.getParent(*context, WTFMove(successCallback), WTFMove(errorCallback));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFileSystemEntryPrototypeFunctionGetParent(ExecState* state)
{
    return IDLOperation<JSFileSystemEntry>::call<jsFileSystemEntryPrototypeFunctionGetParentBody>(*state, "getParent");
}

void JSFileSystemEntry::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSFileSystemEntry*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSFileSystemEntryOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSFileSystemEntryOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsFileSystemEntry = static_cast<JSFileSystemEntry*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsFileSystemEntry->wrapped(), jsFileSystemEntry);
}

FileSystemEntry* JSFileSystemEntry::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSFileSystemEntry*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
