/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSInspectorAuditAccessibilityObject.h"

#include "Document.h"
#include "JSDOMBinding.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSNode.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

template<> InspectorAuditAccessibilityObject::ComputedProperties convertDictionary<InspectorAuditAccessibilityObject::ComputedProperties>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    InspectorAuditAccessibilityObject::ComputedProperties result;
    JSValue busyValue;
    if (isNullOrUndefined)
        busyValue = jsUndefined();
    else {
        busyValue = object->get(&state, Identifier::fromString(&state, "busy"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!busyValue.isUndefined()) {
        result.busy = convert<IDLNullable<IDLBoolean>>(state, busyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue checkedValue;
    if (isNullOrUndefined)
        checkedValue = jsUndefined();
    else {
        checkedValue = object->get(&state, Identifier::fromString(&state, "checked"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!checkedValue.isUndefined()) {
        result.checked = convert<IDLNullable<IDLDOMString>>(state, checkedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue currentStateValue;
    if (isNullOrUndefined)
        currentStateValue = jsUndefined();
    else {
        currentStateValue = object->get(&state, Identifier::fromString(&state, "currentState"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!currentStateValue.isUndefined()) {
        result.currentState = convert<IDLNullable<IDLDOMString>>(state, currentStateValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue disabledValue;
    if (isNullOrUndefined)
        disabledValue = jsUndefined();
    else {
        disabledValue = object->get(&state, Identifier::fromString(&state, "disabled"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!disabledValue.isUndefined()) {
        result.disabled = convert<IDLNullable<IDLBoolean>>(state, disabledValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue expandedValue;
    if (isNullOrUndefined)
        expandedValue = jsUndefined();
    else {
        expandedValue = object->get(&state, Identifier::fromString(&state, "expanded"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!expandedValue.isUndefined()) {
        result.expanded = convert<IDLNullable<IDLBoolean>>(state, expandedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue focusedValue;
    if (isNullOrUndefined)
        focusedValue = jsUndefined();
    else {
        focusedValue = object->get(&state, Identifier::fromString(&state, "focused"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!focusedValue.isUndefined()) {
        result.focused = convert<IDLNullable<IDLBoolean>>(state, focusedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue headingLevelValue;
    if (isNullOrUndefined)
        headingLevelValue = jsUndefined();
    else {
        headingLevelValue = object->get(&state, Identifier::fromString(&state, "headingLevel"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!headingLevelValue.isUndefined()) {
        result.headingLevel = convert<IDLNullable<IDLLong>>(state, headingLevelValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue hiddenValue;
    if (isNullOrUndefined)
        hiddenValue = jsUndefined();
    else {
        hiddenValue = object->get(&state, Identifier::fromString(&state, "hidden"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!hiddenValue.isUndefined()) {
        result.hidden = convert<IDLNullable<IDLBoolean>>(state, hiddenValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue hierarchicalLevelValue;
    if (isNullOrUndefined)
        hierarchicalLevelValue = jsUndefined();
    else {
        hierarchicalLevelValue = object->get(&state, Identifier::fromString(&state, "hierarchicalLevel"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!hierarchicalLevelValue.isUndefined()) {
        result.hierarchicalLevel = convert<IDLNullable<IDLLong>>(state, hierarchicalLevelValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue ignoredValue;
    if (isNullOrUndefined)
        ignoredValue = jsUndefined();
    else {
        ignoredValue = object->get(&state, Identifier::fromString(&state, "ignored"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!ignoredValue.isUndefined()) {
        result.ignored = convert<IDLNullable<IDLBoolean>>(state, ignoredValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue ignoredByDefaultValue;
    if (isNullOrUndefined)
        ignoredByDefaultValue = jsUndefined();
    else {
        ignoredByDefaultValue = object->get(&state, Identifier::fromString(&state, "ignoredByDefault"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!ignoredByDefaultValue.isUndefined()) {
        result.ignoredByDefault = convert<IDLNullable<IDLBoolean>>(state, ignoredByDefaultValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue invalidStatusValue;
    if (isNullOrUndefined)
        invalidStatusValue = jsUndefined();
    else {
        invalidStatusValue = object->get(&state, Identifier::fromString(&state, "invalidStatus"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!invalidStatusValue.isUndefined()) {
        result.invalidStatus = convert<IDLNullable<IDLDOMString>>(state, invalidStatusValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue isPopUpButtonValue;
    if (isNullOrUndefined)
        isPopUpButtonValue = jsUndefined();
    else {
        isPopUpButtonValue = object->get(&state, Identifier::fromString(&state, "isPopUpButton"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!isPopUpButtonValue.isUndefined()) {
        result.isPopUpButton = convert<IDLNullable<IDLBoolean>>(state, isPopUpButtonValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue labelValue;
    if (isNullOrUndefined)
        labelValue = jsUndefined();
    else {
        labelValue = object->get(&state, Identifier::fromString(&state, "label"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!labelValue.isUndefined()) {
        result.label = convert<IDLNullable<IDLDOMString>>(state, labelValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue liveRegionAtomicValue;
    if (isNullOrUndefined)
        liveRegionAtomicValue = jsUndefined();
    else {
        liveRegionAtomicValue = object->get(&state, Identifier::fromString(&state, "liveRegionAtomic"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!liveRegionAtomicValue.isUndefined()) {
        result.liveRegionAtomic = convert<IDLNullable<IDLBoolean>>(state, liveRegionAtomicValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue liveRegionRelevantValue;
    if (isNullOrUndefined)
        liveRegionRelevantValue = jsUndefined();
    else {
        liveRegionRelevantValue = object->get(&state, Identifier::fromString(&state, "liveRegionRelevant"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!liveRegionRelevantValue.isUndefined()) {
        result.liveRegionRelevant = convert<IDLNullable<IDLSequence<IDLDOMString>>>(state, liveRegionRelevantValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue liveRegionStatusValue;
    if (isNullOrUndefined)
        liveRegionStatusValue = jsUndefined();
    else {
        liveRegionStatusValue = object->get(&state, Identifier::fromString(&state, "liveRegionStatus"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!liveRegionStatusValue.isUndefined()) {
        result.liveRegionStatus = convert<IDLNullable<IDLDOMString>>(state, liveRegionStatusValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue pressedValue;
    if (isNullOrUndefined)
        pressedValue = jsUndefined();
    else {
        pressedValue = object->get(&state, Identifier::fromString(&state, "pressed"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!pressedValue.isUndefined()) {
        result.pressed = convert<IDLNullable<IDLBoolean>>(state, pressedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue readonlyValue;
    if (isNullOrUndefined)
        readonlyValue = jsUndefined();
    else {
        readonlyValue = object->get(&state, Identifier::fromString(&state, "readonly"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!readonlyValue.isUndefined()) {
        result.readonly = convert<IDLNullable<IDLBoolean>>(state, readonlyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue requiredValue;
    if (isNullOrUndefined)
        requiredValue = jsUndefined();
    else {
        requiredValue = object->get(&state, Identifier::fromString(&state, "required"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!requiredValue.isUndefined()) {
        result.required = convert<IDLNullable<IDLBoolean>>(state, requiredValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue roleValue;
    if (isNullOrUndefined)
        roleValue = jsUndefined();
    else {
        roleValue = object->get(&state, Identifier::fromString(&state, "role"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!roleValue.isUndefined()) {
        result.role = convert<IDLNullable<IDLDOMString>>(state, roleValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue selectedValue;
    if (isNullOrUndefined)
        selectedValue = jsUndefined();
    else {
        selectedValue = object->get(&state, Identifier::fromString(&state, "selected"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!selectedValue.isUndefined()) {
        result.selected = convert<IDLNullable<IDLBoolean>>(state, selectedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const InspectorAuditAccessibilityObject::ComputedProperties& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.busy)) {
        auto busyValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.busy));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "busy"), busyValue);
    }
    if (!IDLNullable<IDLDOMString>::isNullValue(dictionary.checked)) {
        auto checkedValue = toJS<IDLNullable<IDLDOMString>>(state, IDLNullable<IDLDOMString>::extractValueFromNullable(dictionary.checked));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "checked"), checkedValue);
    }
    if (!IDLNullable<IDLDOMString>::isNullValue(dictionary.currentState)) {
        auto currentStateValue = toJS<IDLNullable<IDLDOMString>>(state, IDLNullable<IDLDOMString>::extractValueFromNullable(dictionary.currentState));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "currentState"), currentStateValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.disabled)) {
        auto disabledValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.disabled));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "disabled"), disabledValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.expanded)) {
        auto expandedValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.expanded));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "expanded"), expandedValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.focused)) {
        auto focusedValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.focused));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "focused"), focusedValue);
    }
    if (!IDLNullable<IDLLong>::isNullValue(dictionary.headingLevel)) {
        auto headingLevelValue = toJS<IDLNullable<IDLLong>>(IDLNullable<IDLLong>::extractValueFromNullable(dictionary.headingLevel));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "headingLevel"), headingLevelValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.hidden)) {
        auto hiddenValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.hidden));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "hidden"), hiddenValue);
    }
    if (!IDLNullable<IDLLong>::isNullValue(dictionary.hierarchicalLevel)) {
        auto hierarchicalLevelValue = toJS<IDLNullable<IDLLong>>(IDLNullable<IDLLong>::extractValueFromNullable(dictionary.hierarchicalLevel));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "hierarchicalLevel"), hierarchicalLevelValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.ignored)) {
        auto ignoredValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.ignored));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "ignored"), ignoredValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.ignoredByDefault)) {
        auto ignoredByDefaultValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.ignoredByDefault));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "ignoredByDefault"), ignoredByDefaultValue);
    }
    if (!IDLNullable<IDLDOMString>::isNullValue(dictionary.invalidStatus)) {
        auto invalidStatusValue = toJS<IDLNullable<IDLDOMString>>(state, IDLNullable<IDLDOMString>::extractValueFromNullable(dictionary.invalidStatus));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "invalidStatus"), invalidStatusValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.isPopUpButton)) {
        auto isPopUpButtonValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.isPopUpButton));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "isPopUpButton"), isPopUpButtonValue);
    }
    if (!IDLNullable<IDLDOMString>::isNullValue(dictionary.label)) {
        auto labelValue = toJS<IDLNullable<IDLDOMString>>(state, IDLNullable<IDLDOMString>::extractValueFromNullable(dictionary.label));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "label"), labelValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.liveRegionAtomic)) {
        auto liveRegionAtomicValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.liveRegionAtomic));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "liveRegionAtomic"), liveRegionAtomicValue);
    }
    if (!IDLNullable<IDLSequence<IDLDOMString>>::isNullValue(dictionary.liveRegionRelevant)) {
        auto liveRegionRelevantValue = toJS<IDLNullable<IDLSequence<IDLDOMString>>>(state, globalObject, IDLNullable<IDLSequence<IDLDOMString>>::extractValueFromNullable(dictionary.liveRegionRelevant));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "liveRegionRelevant"), liveRegionRelevantValue);
    }
    if (!IDLNullable<IDLDOMString>::isNullValue(dictionary.liveRegionStatus)) {
        auto liveRegionStatusValue = toJS<IDLNullable<IDLDOMString>>(state, IDLNullable<IDLDOMString>::extractValueFromNullable(dictionary.liveRegionStatus));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "liveRegionStatus"), liveRegionStatusValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.pressed)) {
        auto pressedValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.pressed));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "pressed"), pressedValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.readonly)) {
        auto readonlyValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.readonly));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "readonly"), readonlyValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.required)) {
        auto requiredValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.required));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "required"), requiredValue);
    }
    if (!IDLNullable<IDLDOMString>::isNullValue(dictionary.role)) {
        auto roleValue = toJS<IDLNullable<IDLDOMString>>(state, IDLNullable<IDLDOMString>::extractValueFromNullable(dictionary.role));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "role"), roleValue);
    }
    if (!IDLNullable<IDLBoolean>::isNullValue(dictionary.selected)) {
        auto selectedValue = toJS<IDLNullable<IDLBoolean>>(IDLNullable<IDLBoolean>::extractValueFromNullable(dictionary.selected));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "selected"), selectedValue);
    }
    return result;
}

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetElementsByComputedRole(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetActiveDescendant(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetChildNodes(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetComputedProperties(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetControlledNodes(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetFlowedNodes(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetMouseEventNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetOwnedNodes(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetParentNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetSelectedChildNodes(JSC::ExecState*);

class JSInspectorAuditAccessibilityObjectPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSInspectorAuditAccessibilityObjectPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSInspectorAuditAccessibilityObjectPrototype* ptr = new (NotNull, JSC::allocateCell<JSInspectorAuditAccessibilityObjectPrototype>(vm.heap)) JSInspectorAuditAccessibilityObjectPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSInspectorAuditAccessibilityObjectPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSInspectorAuditAccessibilityObjectPrototypeTableValues[] =
{
    { "getElementsByComputedRole", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetElementsByComputedRole), (intptr_t) (1) } },
    { "getActiveDescendant", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetActiveDescendant), (intptr_t) (1) } },
    { "getChildNodes", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetChildNodes), (intptr_t) (1) } },
    { "getComputedProperties", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetComputedProperties), (intptr_t) (1) } },
    { "getControlledNodes", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetControlledNodes), (intptr_t) (1) } },
    { "getFlowedNodes", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetFlowedNodes), (intptr_t) (1) } },
    { "getMouseEventNode", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetMouseEventNode), (intptr_t) (1) } },
    { "getOwnedNodes", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetOwnedNodes), (intptr_t) (1) } },
    { "getParentNode", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetParentNode), (intptr_t) (1) } },
    { "getSelectedChildNodes", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsInspectorAuditAccessibilityObjectPrototypeFunctionGetSelectedChildNodes), (intptr_t) (1) } },
};

const ClassInfo JSInspectorAuditAccessibilityObjectPrototype::s_info = { "InspectorAuditAccessibilityObjectPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSInspectorAuditAccessibilityObjectPrototype) };

void JSInspectorAuditAccessibilityObjectPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSInspectorAuditAccessibilityObject::info(), JSInspectorAuditAccessibilityObjectPrototypeTableValues, *this);
}

const ClassInfo JSInspectorAuditAccessibilityObject::s_info = { "InspectorAuditAccessibilityObject", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSInspectorAuditAccessibilityObject) };

JSInspectorAuditAccessibilityObject::JSInspectorAuditAccessibilityObject(Structure* structure, JSDOMGlobalObject& globalObject, Ref<InspectorAuditAccessibilityObject>&& impl)
    : JSDOMWrapper<InspectorAuditAccessibilityObject>(structure, globalObject, WTFMove(impl))
{
}

void JSInspectorAuditAccessibilityObject::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSInspectorAuditAccessibilityObject::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSInspectorAuditAccessibilityObjectPrototype::create(vm, &globalObject, JSInspectorAuditAccessibilityObjectPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSInspectorAuditAccessibilityObject::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSInspectorAuditAccessibilityObject>(vm, globalObject);
}

void JSInspectorAuditAccessibilityObject::destroy(JSC::JSCell* cell)
{
    JSInspectorAuditAccessibilityObject* thisObject = static_cast<JSInspectorAuditAccessibilityObject*>(cell);
    thisObject->JSInspectorAuditAccessibilityObject::~JSInspectorAuditAccessibilityObject();
}

template<> inline JSInspectorAuditAccessibilityObject* IDLOperation<JSInspectorAuditAccessibilityObject>::cast(ExecState& state)
{
    return jsDynamicCast<JSInspectorAuditAccessibilityObject*>(state.vm(), state.thisValue());
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetElementsByComputedRoleBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto* context = jsCast<JSDOMGlobalObject*>(state->lexicalGlobalObject())->scriptExecutionContext();
    if (UNLIKELY(!context))
        return JSValue::encode(jsUndefined());
    ASSERT(context->isDocument());
    auto& document = downcast<Document>(*context);
    auto role = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto container = convert<IDLNullable<IDLInterface<Node>>>(*state, state->argument(1), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 1, "container", "InspectorAuditAccessibilityObject", "getElementsByComputedRole", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLSequence<IDLInterface<Node>>>(*state, *castedThis->globalObject(), throwScope, impl.getElementsByComputedRole(document, WTFMove(role), WTFMove(container))));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetElementsByComputedRole(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetElementsByComputedRoleBody>(*state, "getElementsByComputedRole");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetActiveDescendantBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getActiveDescendant", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLInterface<Node>>>(*state, *castedThis->globalObject(), throwScope, impl.getActiveDescendant(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetActiveDescendant(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetActiveDescendantBody>(*state, "getActiveDescendant");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetChildNodesBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getChildNodes", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLSequence<IDLInterface<Node>>>>(*state, *castedThis->globalObject(), throwScope, impl.getChildNodes(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetChildNodes(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetChildNodesBody>(*state, "getChildNodes");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetComputedPropertiesBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getComputedProperties", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLDictionary<InspectorAuditAccessibilityObject::ComputedProperties>>>(*state, *castedThis->globalObject(), throwScope, impl.getComputedProperties(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetComputedProperties(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetComputedPropertiesBody>(*state, "getComputedProperties");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetControlledNodesBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getControlledNodes", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLSequence<IDLInterface<Node>>>>(*state, *castedThis->globalObject(), throwScope, impl.getControlledNodes(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetControlledNodes(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetControlledNodesBody>(*state, "getControlledNodes");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetFlowedNodesBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getFlowedNodes", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLSequence<IDLInterface<Node>>>>(*state, *castedThis->globalObject(), throwScope, impl.getFlowedNodes(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetFlowedNodes(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetFlowedNodesBody>(*state, "getFlowedNodes");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetMouseEventNodeBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getMouseEventNode", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLInterface<Node>>>(*state, *castedThis->globalObject(), throwScope, impl.getMouseEventNode(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetMouseEventNode(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetMouseEventNodeBody>(*state, "getMouseEventNode");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetOwnedNodesBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getOwnedNodes", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLSequence<IDLInterface<Node>>>>(*state, *castedThis->globalObject(), throwScope, impl.getOwnedNodes(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetOwnedNodes(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetOwnedNodesBody>(*state, "getOwnedNodes");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetParentNodeBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getParentNode", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLInterface<Node>>>(*state, *castedThis->globalObject(), throwScope, impl.getParentNode(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetParentNode(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetParentNodeBody>(*state, "getParentNode");
}

static inline JSC::EncodedJSValue jsInspectorAuditAccessibilityObjectPrototypeFunctionGetSelectedChildNodesBody(JSC::ExecState* state, typename IDLOperation<JSInspectorAuditAccessibilityObject>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLInterface<Node>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "InspectorAuditAccessibilityObject", "getSelectedChildNodes", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLSequence<IDLInterface<Node>>>>(*state, *castedThis->globalObject(), throwScope, impl.getSelectedChildNodes(*node)));
}

EncodedJSValue JSC_HOST_CALL jsInspectorAuditAccessibilityObjectPrototypeFunctionGetSelectedChildNodes(ExecState* state)
{
    return IDLOperation<JSInspectorAuditAccessibilityObject>::call<jsInspectorAuditAccessibilityObjectPrototypeFunctionGetSelectedChildNodesBody>(*state, "getSelectedChildNodes");
}

void JSInspectorAuditAccessibilityObject::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSInspectorAuditAccessibilityObject*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSInspectorAuditAccessibilityObjectOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSInspectorAuditAccessibilityObjectOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsInspectorAuditAccessibilityObject = static_cast<JSInspectorAuditAccessibilityObject*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsInspectorAuditAccessibilityObject->wrapped(), jsInspectorAuditAccessibilityObject);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<InspectorAuditAccessibilityObject>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to InspectorAuditAccessibilityObject.
    static_assert(!std::is_polymorphic<InspectorAuditAccessibilityObject>::value, "InspectorAuditAccessibilityObject is polymorphic but the IDL claims it is not");
    return createWrapper<InspectorAuditAccessibilityObject>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, InspectorAuditAccessibilityObject& impl)
{
    return wrap(state, globalObject, impl);
}

InspectorAuditAccessibilityObject* JSInspectorAuditAccessibilityObject::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSInspectorAuditAccessibilityObject*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
