/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(INTERSECTION_OBSERVER)

#include "JSIntersectionObserverEntry.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMRectInit.h"
#include "JSDOMRectReadOnly.h"
#include "JSDOMWrapperCache.h"
#include "JSElement.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(INTERSECTION_OBSERVER)

template<> IntersectionObserverEntry::Init convertDictionary<IntersectionObserverEntry::Init>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    IntersectionObserverEntry::Init result;
    JSValue boundingClientRectValue;
    if (isNullOrUndefined)
        boundingClientRectValue = jsUndefined();
    else {
        boundingClientRectValue = object->get(&state, Identifier::fromString(&state, "boundingClientRect"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!boundingClientRectValue.isUndefined()) {
        result.boundingClientRect = convert<IDLDictionary<DOMRectInit>>(state, boundingClientRectValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "boundingClientRect", "IntersectionObserverEntryInit", "DOMRectInit");
        return { };
    }
    JSValue intersectionRatioValue;
    if (isNullOrUndefined)
        intersectionRatioValue = jsUndefined();
    else {
        intersectionRatioValue = object->get(&state, Identifier::fromString(&state, "intersectionRatio"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!intersectionRatioValue.isUndefined()) {
        result.intersectionRatio = convert<IDLDouble>(state, intersectionRatioValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "intersectionRatio", "IntersectionObserverEntryInit", "double");
        return { };
    }
    JSValue intersectionRectValue;
    if (isNullOrUndefined)
        intersectionRectValue = jsUndefined();
    else {
        intersectionRectValue = object->get(&state, Identifier::fromString(&state, "intersectionRect"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!intersectionRectValue.isUndefined()) {
        result.intersectionRect = convert<IDLDictionary<DOMRectInit>>(state, intersectionRectValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "intersectionRect", "IntersectionObserverEntryInit", "DOMRectInit");
        return { };
    }
    JSValue isIntersectingValue;
    if (isNullOrUndefined)
        isIntersectingValue = jsUndefined();
    else {
        isIntersectingValue = object->get(&state, Identifier::fromString(&state, "isIntersecting"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!isIntersectingValue.isUndefined()) {
        result.isIntersecting = convert<IDLBoolean>(state, isIntersectingValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "isIntersecting", "IntersectionObserverEntryInit", "boolean");
        return { };
    }
    JSValue rootBoundsValue;
    if (isNullOrUndefined)
        rootBoundsValue = jsUndefined();
    else {
        rootBoundsValue = object->get(&state, Identifier::fromString(&state, "rootBounds"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!rootBoundsValue.isUndefined()) {
        result.rootBounds = convert<IDLNullable<IDLDictionary<DOMRectInit>>>(state, rootBoundsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "rootBounds", "IntersectionObserverEntryInit", "DOMRectInit");
        return { };
    }
    JSValue targetValue;
    if (isNullOrUndefined)
        targetValue = jsUndefined();
    else {
        targetValue = object->get(&state, Identifier::fromString(&state, "target"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!targetValue.isUndefined()) {
        result.target = convert<IDLInterface<Element>>(state, targetValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "target", "IntersectionObserverEntryInit", "Element");
        return { };
    }
    JSValue timeValue;
    if (isNullOrUndefined)
        timeValue = jsUndefined();
    else {
        timeValue = object->get(&state, Identifier::fromString(&state, "time"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!timeValue.isUndefined()) {
        result.time = convert<IDLDouble>(state, timeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "time", "IntersectionObserverEntryInit", "double");
        return { };
    }
    return result;
}

#endif

// Attributes

JSC::EncodedJSValue jsIntersectionObserverEntryConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSIntersectionObserverEntryConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsIntersectionObserverEntryTime(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsIntersectionObserverEntryRootBounds(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsIntersectionObserverEntryBoundingClientRect(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsIntersectionObserverEntryIntersectionRect(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsIntersectionObserverEntryIsIntersecting(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsIntersectionObserverEntryIntersectionRatio(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsIntersectionObserverEntryTarget(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSIntersectionObserverEntryPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSIntersectionObserverEntryPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSIntersectionObserverEntryPrototype* ptr = new (NotNull, JSC::allocateCell<JSIntersectionObserverEntryPrototype>(vm.heap)) JSIntersectionObserverEntryPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSIntersectionObserverEntryPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSIntersectionObserverEntryConstructor = JSDOMConstructor<JSIntersectionObserverEntry>;

template<> EncodedJSValue JSC_HOST_CALL JSIntersectionObserverEntryConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSIntersectionObserverEntryConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto intersectionObserverEntryInit = convert<IDLDictionary<IntersectionObserverEntry::Init>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = IntersectionObserverEntry::create(WTFMove(intersectionObserverEntryInit));
    return JSValue::encode(toJSNewlyCreated<IDLInterface<IntersectionObserverEntry>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSIntersectionObserverEntryConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSIntersectionObserverEntryConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSIntersectionObserverEntry::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("IntersectionObserverEntry"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSIntersectionObserverEntryConstructor::s_info = { "IntersectionObserverEntry", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSIntersectionObserverEntryConstructor) };

/* Hash table for prototype */

static const HashTableValue JSIntersectionObserverEntryPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSIntersectionObserverEntryConstructor) } },
    { "time", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryTime), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "rootBounds", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryRootBounds), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "boundingClientRect", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryBoundingClientRect), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "intersectionRect", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryIntersectionRect), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "isIntersecting", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryIsIntersecting), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "intersectionRatio", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryIntersectionRatio), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "target", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsIntersectionObserverEntryTarget), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSIntersectionObserverEntryPrototype::s_info = { "IntersectionObserverEntryPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSIntersectionObserverEntryPrototype) };

void JSIntersectionObserverEntryPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSIntersectionObserverEntry::info(), JSIntersectionObserverEntryPrototypeTableValues, *this);
}

const ClassInfo JSIntersectionObserverEntry::s_info = { "IntersectionObserverEntry", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSIntersectionObserverEntry) };

JSIntersectionObserverEntry::JSIntersectionObserverEntry(Structure* structure, JSDOMGlobalObject& globalObject, Ref<IntersectionObserverEntry>&& impl)
    : JSDOMWrapper<IntersectionObserverEntry>(structure, globalObject, WTFMove(impl))
{
}

void JSIntersectionObserverEntry::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSIntersectionObserverEntry::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSIntersectionObserverEntryPrototype::create(vm, &globalObject, JSIntersectionObserverEntryPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSIntersectionObserverEntry::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSIntersectionObserverEntry>(vm, globalObject);
}

JSValue JSIntersectionObserverEntry::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSIntersectionObserverEntryConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSIntersectionObserverEntry::destroy(JSC::JSCell* cell)
{
    JSIntersectionObserverEntry* thisObject = static_cast<JSIntersectionObserverEntry*>(cell);
    thisObject->JSIntersectionObserverEntry::~JSIntersectionObserverEntry();
}

template<> inline JSIntersectionObserverEntry* IDLAttribute<JSIntersectionObserverEntry>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSIntersectionObserverEntry*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsIntersectionObserverEntryConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSIntersectionObserverEntryPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSIntersectionObserverEntry::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSIntersectionObserverEntryConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSIntersectionObserverEntryPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsIntersectionObserverEntryTimeGetter(ExecState& state, JSIntersectionObserverEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.time());
    return result;
}

EncodedJSValue jsIntersectionObserverEntryTime(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSIntersectionObserverEntry>::get<jsIntersectionObserverEntryTimeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "time");
}

static inline JSValue jsIntersectionObserverEntryRootBoundsGetter(ExecState& state, JSIntersectionObserverEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<DOMRectReadOnly>>>(state, *thisObject.globalObject(), throwScope, impl.rootBounds());
    return result;
}

EncodedJSValue jsIntersectionObserverEntryRootBounds(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSIntersectionObserverEntry>::get<jsIntersectionObserverEntryRootBoundsGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "rootBounds");
}

static inline JSValue jsIntersectionObserverEntryBoundingClientRectGetter(ExecState& state, JSIntersectionObserverEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DOMRectReadOnly>>(state, *thisObject.globalObject(), throwScope, impl.boundingClientRect());
    return result;
}

EncodedJSValue jsIntersectionObserverEntryBoundingClientRect(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSIntersectionObserverEntry>::get<jsIntersectionObserverEntryBoundingClientRectGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "boundingClientRect");
}

static inline JSValue jsIntersectionObserverEntryIntersectionRectGetter(ExecState& state, JSIntersectionObserverEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<DOMRectReadOnly>>(state, *thisObject.globalObject(), throwScope, impl.intersectionRect());
    return result;
}

EncodedJSValue jsIntersectionObserverEntryIntersectionRect(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSIntersectionObserverEntry>::get<jsIntersectionObserverEntryIntersectionRectGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "intersectionRect");
}

static inline JSValue jsIntersectionObserverEntryIsIntersectingGetter(ExecState& state, JSIntersectionObserverEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.isIntersecting());
    return result;
}

EncodedJSValue jsIntersectionObserverEntryIsIntersecting(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSIntersectionObserverEntry>::get<jsIntersectionObserverEntryIsIntersectingGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "isIntersecting");
}

static inline JSValue jsIntersectionObserverEntryIntersectionRatioGetter(ExecState& state, JSIntersectionObserverEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.intersectionRatio());
    return result;
}

EncodedJSValue jsIntersectionObserverEntryIntersectionRatio(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSIntersectionObserverEntry>::get<jsIntersectionObserverEntryIntersectionRatioGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "intersectionRatio");
}

static inline JSValue jsIntersectionObserverEntryTargetGetter(ExecState& state, JSIntersectionObserverEntry& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<Element>>(state, *thisObject.globalObject(), throwScope, impl.target());
    return result;
}

EncodedJSValue jsIntersectionObserverEntryTarget(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSIntersectionObserverEntry>::get<jsIntersectionObserverEntryTargetGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "target");
}

void JSIntersectionObserverEntry::visitChildren(JSCell* cell, SlotVisitor& visitor)
{
    auto* thisObject = jsCast<JSIntersectionObserverEntry*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
    thisObject->visitAdditionalChildren(visitor);
}

void JSIntersectionObserverEntry::visitOutputConstraints(JSCell* cell, SlotVisitor& visitor)
{
    auto* thisObject = jsCast<JSIntersectionObserverEntry*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitOutputConstraints(thisObject, visitor);
    thisObject->visitAdditionalChildren(visitor);
}

void JSIntersectionObserverEntry::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSIntersectionObserverEntry*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSIntersectionObserverEntryOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSIntersectionObserverEntryOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsIntersectionObserverEntry = static_cast<JSIntersectionObserverEntry*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsIntersectionObserverEntry->wrapped(), jsIntersectionObserverEntry);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<IntersectionObserverEntry>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to IntersectionObserverEntry.
    static_assert(!std::is_polymorphic<IntersectionObserverEntry>::value, "IntersectionObserverEntry is polymorphic but the IDL claims it is not");
    return createWrapper<IntersectionObserverEntry>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, IntersectionObserverEntry& impl)
{
    return wrap(state, globalObject, impl);
}

IntersectionObserverEntry* JSIntersectionObserverEntry::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSIntersectionObserverEntry*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(INTERSECTION_OBSERVER)
