/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMediaCapabilities.h"

#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSMediaDecodingConfiguration.h"
#include "JSMediaEncodingConfiguration.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsMediaCapabilitiesPrototypeFunctionDecodingInfo(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsMediaCapabilitiesPrototypeFunctionEncodingInfo(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsMediaCapabilitiesConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSMediaCapabilitiesConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSMediaCapabilitiesPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSMediaCapabilitiesPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMediaCapabilitiesPrototype* ptr = new (NotNull, JSC::allocateCell<JSMediaCapabilitiesPrototype>(vm.heap)) JSMediaCapabilitiesPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMediaCapabilitiesPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSMediaCapabilitiesConstructor = JSDOMConstructorNotConstructable<JSMediaCapabilities>;

template<> JSValue JSMediaCapabilitiesConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSMediaCapabilitiesConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSMediaCapabilities::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("MediaCapabilities"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSMediaCapabilitiesConstructor::s_info = { "MediaCapabilities", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaCapabilitiesConstructor) };

/* Hash table for prototype */

static const HashTableValue JSMediaCapabilitiesPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaCapabilitiesConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMediaCapabilitiesConstructor) } },
    { "decodingInfo", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaCapabilitiesPrototypeFunctionDecodingInfo), (intptr_t) (1) } },
    { "encodingInfo", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMediaCapabilitiesPrototypeFunctionEncodingInfo), (intptr_t) (1) } },
};

const ClassInfo JSMediaCapabilitiesPrototype::s_info = { "MediaCapabilitiesPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaCapabilitiesPrototype) };

void JSMediaCapabilitiesPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMediaCapabilities::info(), JSMediaCapabilitiesPrototypeTableValues, *this);
}

const ClassInfo JSMediaCapabilities::s_info = { "MediaCapabilities", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMediaCapabilities) };

JSMediaCapabilities::JSMediaCapabilities(Structure* structure, JSDOMGlobalObject& globalObject, Ref<MediaCapabilities>&& impl)
    : JSDOMWrapper<MediaCapabilities>(structure, globalObject, WTFMove(impl))
{
}

void JSMediaCapabilities::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSMediaCapabilities::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSMediaCapabilitiesPrototype::create(vm, &globalObject, JSMediaCapabilitiesPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSMediaCapabilities::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSMediaCapabilities>(vm, globalObject);
}

JSValue JSMediaCapabilities::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSMediaCapabilitiesConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSMediaCapabilities::destroy(JSC::JSCell* cell)
{
    JSMediaCapabilities* thisObject = static_cast<JSMediaCapabilities*>(cell);
    thisObject->JSMediaCapabilities::~JSMediaCapabilities();
}

template<> inline JSMediaCapabilities* IDLOperation<JSMediaCapabilities>::cast(ExecState& state)
{
    return jsDynamicCast<JSMediaCapabilities*>(state.vm(), state.thisValue());
}

EncodedJSValue jsMediaCapabilitiesConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSMediaCapabilitiesPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSMediaCapabilities::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSMediaCapabilitiesConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSMediaCapabilitiesPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsMediaCapabilitiesPrototypeFunctionDecodingInfoBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSMediaCapabilities>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto configuration = convert<IDLDictionary<MediaDecodingConfiguration>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.decodingInfo(WTFMove(configuration), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsMediaCapabilitiesPrototypeFunctionDecodingInfo(ExecState* state)
{
    return IDLOperationReturningPromise<JSMediaCapabilities>::call<jsMediaCapabilitiesPrototypeFunctionDecodingInfoBody, PromiseExecutionScope::WindowOnly>(*state, "decodingInfo");
}

static inline JSC::EncodedJSValue jsMediaCapabilitiesPrototypeFunctionEncodingInfoBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSMediaCapabilities>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto configuration = convert<IDLDictionary<MediaEncodingConfiguration>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.encodingInfo(WTFMove(configuration), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsMediaCapabilitiesPrototypeFunctionEncodingInfo(ExecState* state)
{
    return IDLOperationReturningPromise<JSMediaCapabilities>::call<jsMediaCapabilitiesPrototypeFunctionEncodingInfoBody, PromiseExecutionScope::WindowOnly>(*state, "encodingInfo");
}

void JSMediaCapabilities::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSMediaCapabilities*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSMediaCapabilitiesOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSMediaCapabilitiesOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsMediaCapabilities = static_cast<JSMediaCapabilities*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMediaCapabilities->wrapped(), jsMediaCapabilities);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<MediaCapabilities>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to MediaCapabilities.
    static_assert(!std::is_polymorphic<MediaCapabilities>::value, "MediaCapabilities is polymorphic but the IDL claims it is not");
    return createWrapper<MediaCapabilities>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, MediaCapabilities& impl)
{
    return wrap(state, globalObject, impl);
}

MediaCapabilities* JSMediaCapabilities::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSMediaCapabilities*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
