/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSOffscreenCanvas.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSImageBitmap.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>

#if ENABLE(WEBGL)
#include "JSDOMConvertAny.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertVariadic.h"
#include "JSWebGLRenderingContext.h"
#endif


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(OffscreenCanvas::RenderingContextType enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("2d"),
        MAKE_STATIC_STRING_IMPL("webgl"),
    };
    static_assert(static_cast<size_t>(OffscreenCanvas::RenderingContextType::_2d) == 0, "OffscreenCanvas::RenderingContextType::_2d is not 0 as expected");
    static_assert(static_cast<size_t>(OffscreenCanvas::RenderingContextType::Webgl) == 1, "OffscreenCanvas::RenderingContextType::Webgl is not 1 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(ExecState& state, OffscreenCanvas::RenderingContextType enumerationValue)
{
    return jsStringWithCache(&state, convertEnumerationToString(enumerationValue));
}

template<> Optional<OffscreenCanvas::RenderingContextType> parseEnumeration<OffscreenCanvas::RenderingContextType>(ExecState& state, JSValue value)
{
    auto stringValue = value.toWTFString(&state);
    if (stringValue == "2d")
        return OffscreenCanvas::RenderingContextType::_2d;
    if (stringValue == "webgl")
        return OffscreenCanvas::RenderingContextType::Webgl;
    return WTF::nullopt;
}

template<> const char* expectedEnumerationValues<OffscreenCanvas::RenderingContextType>()
{
    return "\"2d\", \"webgl\"";
}

template<> OffscreenCanvas::ImageEncodeOptions convertDictionary<OffscreenCanvas::ImageEncodeOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    OffscreenCanvas::ImageEncodeOptions result;
    JSValue qualityValue;
    if (isNullOrUndefined)
        qualityValue = jsUndefined();
    else {
        qualityValue = object->get(&state, Identifier::fromString(&state, "quality"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!qualityValue.isUndefined()) {
        result.quality = convert<IDLUnrestrictedDouble>(state, qualityValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.quality = 1.0;
    JSValue typeValue;
    if (isNullOrUndefined)
        typeValue = jsUndefined();
    else {
        typeValue = object->get(&state, Identifier::fromString(&state, "type"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!typeValue.isUndefined()) {
        result.type = convert<IDLDOMString>(state, typeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.type = "image/png"_s;
    return result;
}

// Functions

#if ENABLE(WEBGL)
JSC::EncodedJSValue JSC_HOST_CALL jsOffscreenCanvasPrototypeFunctionGetContext(JSC::ExecState*);
#endif
JSC::EncodedJSValue JSC_HOST_CALL jsOffscreenCanvasPrototypeFunctionTransferToImageBitmap(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsOffscreenCanvasConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSOffscreenCanvasConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsOffscreenCanvasWidth(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSOffscreenCanvasWidth(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsOffscreenCanvasHeight(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSOffscreenCanvasHeight(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSOffscreenCanvasPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSOffscreenCanvasPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSOffscreenCanvasPrototype* ptr = new (NotNull, JSC::allocateCell<JSOffscreenCanvasPrototype>(vm.heap)) JSOffscreenCanvasPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSOffscreenCanvasPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSOffscreenCanvasConstructor = JSDOMConstructor<JSOffscreenCanvas>;

template<> EncodedJSValue JSC_HOST_CALL JSOffscreenCanvasConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSOffscreenCanvasConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(state->argumentCount() < 2))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto* context = castedThis->scriptExecutionContext();
    if (UNLIKELY(!context))
        return throwConstructorScriptExecutionContextUnavailableError(*state, throwScope, "OffscreenCanvas");
    auto width = convert<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto height = convert<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(*state, state->uncheckedArgument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = OffscreenCanvas::create(*context, WTFMove(width), WTFMove(height));
    return JSValue::encode(toJSNewlyCreated<IDLInterface<OffscreenCanvas>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSOffscreenCanvasConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEventTarget::getConstructor(vm, &globalObject);
}

template<> void JSOffscreenCanvasConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSOffscreenCanvas::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("OffscreenCanvas"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(2), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSOffscreenCanvasConstructor::s_info = { "OffscreenCanvas", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSOffscreenCanvasConstructor) };

/* Hash table for prototype */

static const HashTableValue JSOffscreenCanvasPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsOffscreenCanvasConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSOffscreenCanvasConstructor) } },
    { "width", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsOffscreenCanvasWidth), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSOffscreenCanvasWidth) } },
    { "height", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsOffscreenCanvasHeight), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSOffscreenCanvasHeight) } },
#if ENABLE(WEBGL)
    { "getContext", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsOffscreenCanvasPrototypeFunctionGetContext), (intptr_t) (1) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
    { "transferToImageBitmap", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsOffscreenCanvasPrototypeFunctionTransferToImageBitmap), (intptr_t) (0) } },
};

const ClassInfo JSOffscreenCanvasPrototype::s_info = { "OffscreenCanvasPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSOffscreenCanvasPrototype) };

void JSOffscreenCanvasPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSOffscreenCanvas::info(), JSOffscreenCanvasPrototypeTableValues, *this);
}

const ClassInfo JSOffscreenCanvas::s_info = { "OffscreenCanvas", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSOffscreenCanvas) };

JSOffscreenCanvas::JSOffscreenCanvas(Structure* structure, JSDOMGlobalObject& globalObject, Ref<OffscreenCanvas>&& impl)
    : JSEventTarget(structure, globalObject, WTFMove(impl))
{
}

void JSOffscreenCanvas::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSOffscreenCanvas::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSOffscreenCanvasPrototype::create(vm, &globalObject, JSOffscreenCanvasPrototype::createStructure(vm, &globalObject, JSEventTarget::prototype(vm, globalObject)));
}

JSObject* JSOffscreenCanvas::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSOffscreenCanvas>(vm, globalObject);
}

JSValue JSOffscreenCanvas::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSOffscreenCanvasConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSOffscreenCanvas* IDLAttribute<JSOffscreenCanvas>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSOffscreenCanvas*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSOffscreenCanvas* IDLOperation<JSOffscreenCanvas>::cast(ExecState& state)
{
    return jsDynamicCast<JSOffscreenCanvas*>(state.vm(), state.thisValue());
}

EncodedJSValue jsOffscreenCanvasConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSOffscreenCanvasPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSOffscreenCanvas::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSOffscreenCanvasConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSOffscreenCanvasPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsOffscreenCanvasWidthGetter(ExecState& state, JSOffscreenCanvas& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(state, throwScope, impl.width());
    return result;
}

EncodedJSValue jsOffscreenCanvasWidth(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSOffscreenCanvas>::get<jsOffscreenCanvasWidthGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "width");
}

static inline bool setJSOffscreenCanvasWidthSetter(ExecState& state, JSOffscreenCanvas& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setWidth(WTFMove(nativeValue));
    });
    return true;
}

bool setJSOffscreenCanvasWidth(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSOffscreenCanvas>::set<setJSOffscreenCanvasWidthSetter>(*state, thisValue, encodedValue, "width");
}

static inline JSValue jsOffscreenCanvasHeightGetter(ExecState& state, JSOffscreenCanvas& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(state, throwScope, impl.height());
    return result;
}

EncodedJSValue jsOffscreenCanvasHeight(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSOffscreenCanvas>::get<jsOffscreenCanvasHeightGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "height");
}

static inline bool setJSOffscreenCanvasHeightSetter(ExecState& state, JSOffscreenCanvas& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLEnforceRangeAdaptor<IDLUnsignedLong>>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setHeight(WTFMove(nativeValue));
    });
    return true;
}

bool setJSOffscreenCanvasHeight(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSOffscreenCanvas>::set<setJSOffscreenCanvasHeightSetter>(*state, thisValue, encodedValue, "height");
}

#if ENABLE(WEBGL)
static inline JSC::EncodedJSValue jsOffscreenCanvasPrototypeFunctionGetContextBody(JSC::ExecState* state, typename IDLOperation<JSOffscreenCanvas>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto contextType = convert<IDLEnumeration<OffscreenCanvas::RenderingContextType>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentMustBeEnumError(state, scope, 0, "contextType", "OffscreenCanvas", "getContext", expectedEnumerationValues<OffscreenCanvas::RenderingContextType>()); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto arguments = convertVariadicArguments<IDLAny>(*state, 1);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLNullable<IDLInterface<WebGLRenderingContext>>>(*state, *castedThis->globalObject(), throwScope, impl.getContext(*state, WTFMove(contextType), WTFMove(arguments))));
}

EncodedJSValue JSC_HOST_CALL jsOffscreenCanvasPrototypeFunctionGetContext(ExecState* state)
{
    return IDLOperation<JSOffscreenCanvas>::call<jsOffscreenCanvasPrototypeFunctionGetContextBody>(*state, "getContext");
}

#endif

static inline JSC::EncodedJSValue jsOffscreenCanvasPrototypeFunctionTransferToImageBitmapBody(JSC::ExecState* state, typename IDLOperation<JSOffscreenCanvas>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLInterface<ImageBitmap>>(*state, *castedThis->globalObject(), impl.transferToImageBitmap()));
}

EncodedJSValue JSC_HOST_CALL jsOffscreenCanvasPrototypeFunctionTransferToImageBitmap(ExecState* state)
{
    return IDLOperation<JSOffscreenCanvas>::call<jsOffscreenCanvasPrototypeFunctionTransferToImageBitmapBody>(*state, "transferToImageBitmap");
}

void JSOffscreenCanvas::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSOffscreenCanvas*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSOffscreenCanvasOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    auto* jsOffscreenCanvas = jsCast<JSOffscreenCanvas*>(handle.slot()->asCell());
    if (jsOffscreenCanvas->wrapped().isFiringEventListeners()) {
        if (UNLIKELY(reason))
            *reason = "EventTarget firing event listeners";
        return true;
    }
    OffscreenCanvas* root = &jsOffscreenCanvas->wrapped();
    if (UNLIKELY(reason))
        *reason = "Reachable from OffscreenCanvas";
    return root && visitor.containsOpaqueRoot(root);
}

void JSOffscreenCanvasOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsOffscreenCanvas = static_cast<JSOffscreenCanvas*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsOffscreenCanvas->wrapped(), jsOffscreenCanvas);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7OffscreenCanvas@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15OffscreenCanvasE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<OffscreenCanvas>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(__identifier("??_7OffscreenCanvas@WebCore@@6B@"));
#else
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(&_ZTVN7WebCore15OffscreenCanvasE[2]);
#endif

    // If this fails OffscreenCanvas does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<OffscreenCanvas>::value, "OffscreenCanvas is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // OffscreenCanvas has subclasses. If OffscreenCanvas has subclasses that get passed
    // to toJS() we currently require OffscreenCanvas you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<OffscreenCanvas>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, OffscreenCanvas& impl)
{
    return wrap(state, globalObject, impl);
}

OffscreenCanvas* JSOffscreenCanvas::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSOffscreenCanvas*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
