/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_CRYPTO)

#include "JSRsaOtherPrimesInfo.h"

#include "JSDOMConvertStrings.h"
#include "JSDOMGlobalObject.h"
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(WEB_CRYPTO)

template<> RsaOtherPrimesInfo convertDictionary<RsaOtherPrimesInfo>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    RsaOtherPrimesInfo result;
    JSValue dValue;
    if (isNullOrUndefined)
        dValue = jsUndefined();
    else {
        dValue = object->get(&state, Identifier::fromString(&state, "d"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!dValue.isUndefined()) {
        result.d = convert<IDLDOMString>(state, dValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "d", "RsaOtherPrimesInfo", "DOMString");
        return { };
    }
    JSValue rValue;
    if (isNullOrUndefined)
        rValue = jsUndefined();
    else {
        rValue = object->get(&state, Identifier::fromString(&state, "r"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!rValue.isUndefined()) {
        result.r = convert<IDLDOMString>(state, rValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "r", "RsaOtherPrimesInfo", "DOMString");
        return { };
    }
    JSValue tValue;
    if (isNullOrUndefined)
        tValue = jsUndefined();
    else {
        tValue = object->get(&state, Identifier::fromString(&state, "t"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!tValue.isUndefined()) {
        result.t = convert<IDLDOMString>(state, tValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "t", "RsaOtherPrimesInfo", "DOMString");
        return { };
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const RsaOtherPrimesInfo& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto dValue = toJS<IDLDOMString>(state, dictionary.d);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "d"), dValue);
    auto rValue = toJS<IDLDOMString>(state, dictionary.r);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "r"), rValue);
    auto tValue = toJS<IDLDOMString>(state, dictionary.t);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "t"), tValue);
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(WEB_CRYPTO)
