/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSSVGGeometryElement.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMPointInit.h"
#include "JSDOMWrapperCache.h"
#include "JSSVGAnimatedNumber.h"
#include "JSSVGPoint.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionIsPointInFill(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionIsPointInStroke(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionGetTotalLength(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionGetPointAtLength(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsSVGGeometryElementConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSSVGGeometryElementConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsSVGGeometryElementPathLength(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSSVGGeometryElementPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSSVGGeometryElementPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSSVGGeometryElementPrototype* ptr = new (NotNull, JSC::allocateCell<JSSVGGeometryElementPrototype>(vm.heap)) JSSVGGeometryElementPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSSVGGeometryElementPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSSVGGeometryElementConstructor = JSDOMConstructorNotConstructable<JSSVGGeometryElement>;

template<> JSValue JSSVGGeometryElementConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSSVGGraphicsElement::getConstructor(vm, &globalObject);
}

template<> void JSSVGGeometryElementConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSSVGGeometryElement::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("SVGGeometryElement"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSSVGGeometryElementConstructor::s_info = { "SVGGeometryElement", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSVGGeometryElementConstructor) };

/* Hash table for prototype */

static const HashTableValue JSSVGGeometryElementPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSVGGeometryElementConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSSVGGeometryElementConstructor) } },
    { "pathLength", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSVGGeometryElementPathLength), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "isPointInFill", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsSVGGeometryElementPrototypeFunctionIsPointInFill), (intptr_t) (0) } },
    { "isPointInStroke", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsSVGGeometryElementPrototypeFunctionIsPointInStroke), (intptr_t) (0) } },
    { "getTotalLength", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsSVGGeometryElementPrototypeFunctionGetTotalLength), (intptr_t) (0) } },
    { "getPointAtLength", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsSVGGeometryElementPrototypeFunctionGetPointAtLength), (intptr_t) (1) } },
};

const ClassInfo JSSVGGeometryElementPrototype::s_info = { "SVGGeometryElementPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSVGGeometryElementPrototype) };

void JSSVGGeometryElementPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSSVGGeometryElement::info(), JSSVGGeometryElementPrototypeTableValues, *this);
}

const ClassInfo JSSVGGeometryElement::s_info = { "SVGGeometryElement", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSVGGeometryElement) };

JSSVGGeometryElement::JSSVGGeometryElement(Structure* structure, JSDOMGlobalObject& globalObject, Ref<SVGGeometryElement>&& impl)
    : JSSVGGraphicsElement(structure, globalObject, WTFMove(impl))
{
}

void JSSVGGeometryElement::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSSVGGeometryElement::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSSVGGeometryElementPrototype::create(vm, &globalObject, JSSVGGeometryElementPrototype::createStructure(vm, &globalObject, JSSVGGraphicsElement::prototype(vm, globalObject)));
}

JSObject* JSSVGGeometryElement::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSSVGGeometryElement>(vm, globalObject);
}

JSValue JSSVGGeometryElement::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSSVGGeometryElementConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSSVGGeometryElement* IDLAttribute<JSSVGGeometryElement>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSSVGGeometryElement*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSSVGGeometryElement* IDLOperation<JSSVGGeometryElement>::cast(ExecState& state)
{
    return jsDynamicCast<JSSVGGeometryElement*>(state.vm(), state.thisValue());
}

EncodedJSValue jsSVGGeometryElementConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSSVGGeometryElementPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSSVGGeometryElement::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSSVGGeometryElementConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSSVGGeometryElementPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsSVGGeometryElementPathLengthGetter(ExecState& state, JSSVGGeometryElement& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<SVGAnimatedNumber>>(state, *thisObject.globalObject(), throwScope, impl.pathLengthAnimated());
    return result;
}

EncodedJSValue jsSVGGeometryElementPathLength(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSSVGGeometryElement>::get<jsSVGGeometryElementPathLengthGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "pathLength");
}

static inline JSC::EncodedJSValue jsSVGGeometryElementPrototypeFunctionIsPointInFillBody(JSC::ExecState* state, typename IDLOperation<JSSVGGeometryElement>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto point = convert<IDLDictionary<DOMPointInit>>(*state, state->argument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLBoolean>(impl.isPointInFill(WTFMove(point))));
}

EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionIsPointInFill(ExecState* state)
{
    return IDLOperation<JSSVGGeometryElement>::call<jsSVGGeometryElementPrototypeFunctionIsPointInFillBody>(*state, "isPointInFill");
}

static inline JSC::EncodedJSValue jsSVGGeometryElementPrototypeFunctionIsPointInStrokeBody(JSC::ExecState* state, typename IDLOperation<JSSVGGeometryElement>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto point = convert<IDLDictionary<DOMPointInit>>(*state, state->argument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLBoolean>(impl.isPointInStroke(WTFMove(point))));
}

EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionIsPointInStroke(ExecState* state)
{
    return IDLOperation<JSSVGGeometryElement>::call<jsSVGGeometryElementPrototypeFunctionIsPointInStrokeBody>(*state, "isPointInStroke");
}

static inline JSC::EncodedJSValue jsSVGGeometryElementPrototypeFunctionGetTotalLengthBody(JSC::ExecState* state, typename IDLOperation<JSSVGGeometryElement>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLUnrestrictedFloat>(impl.getTotalLength()));
}

EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionGetTotalLength(ExecState* state)
{
    return IDLOperation<JSSVGGeometryElement>::call<jsSVGGeometryElementPrototypeFunctionGetTotalLengthBody>(*state, "getTotalLength");
}

static inline JSC::EncodedJSValue jsSVGGeometryElementPrototypeFunctionGetPointAtLengthBody(JSC::ExecState* state, typename IDLOperation<JSSVGGeometryElement>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto distance = convert<IDLFloat>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJSNewlyCreated<IDLInterface<SVGPoint>>(*state, *castedThis->globalObject(), impl.getPointAtLength(WTFMove(distance))));
}

EncodedJSValue JSC_HOST_CALL jsSVGGeometryElementPrototypeFunctionGetPointAtLength(ExecState* state)
{
    return IDLOperation<JSSVGGeometryElement>::call<jsSVGGeometryElementPrototypeFunctionGetPointAtLengthBody>(*state, "getPointAtLength");
}

void JSSVGGeometryElement::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSSVGGeometryElement*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}


}
