/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSScreenLuminance.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsScreenLuminanceConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSScreenLuminanceConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsScreenLuminanceMin(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsScreenLuminanceMax(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsScreenLuminanceMaxAverage(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSScreenLuminancePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSScreenLuminancePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSScreenLuminancePrototype* ptr = new (NotNull, JSC::allocateCell<JSScreenLuminancePrototype>(vm.heap)) JSScreenLuminancePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSScreenLuminancePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSScreenLuminanceConstructor = JSDOMConstructorNotConstructable<JSScreenLuminance>;

template<> JSValue JSScreenLuminanceConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSScreenLuminanceConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSScreenLuminance::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("ScreenLuminance"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSScreenLuminanceConstructor::s_info = { "ScreenLuminance", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSScreenLuminanceConstructor) };

/* Hash table for prototype */

static const HashTableValue JSScreenLuminancePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsScreenLuminanceConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSScreenLuminanceConstructor) } },
    { "min", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsScreenLuminanceMin), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "max", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsScreenLuminanceMax), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "maxAverage", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsScreenLuminanceMaxAverage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSScreenLuminancePrototype::s_info = { "ScreenLuminancePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSScreenLuminancePrototype) };

void JSScreenLuminancePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSScreenLuminance::info(), JSScreenLuminancePrototypeTableValues, *this);
}

const ClassInfo JSScreenLuminance::s_info = { "ScreenLuminance", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSScreenLuminance) };

JSScreenLuminance::JSScreenLuminance(Structure* structure, JSDOMGlobalObject& globalObject, Ref<ScreenLuminance>&& impl)
    : JSDOMWrapper<ScreenLuminance>(structure, globalObject, WTFMove(impl))
{
}

void JSScreenLuminance::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSScreenLuminance::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSScreenLuminancePrototype::create(vm, &globalObject, JSScreenLuminancePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSScreenLuminance::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSScreenLuminance>(vm, globalObject);
}

JSValue JSScreenLuminance::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSScreenLuminanceConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSScreenLuminance::destroy(JSC::JSCell* cell)
{
    JSScreenLuminance* thisObject = static_cast<JSScreenLuminance*>(cell);
    thisObject->JSScreenLuminance::~JSScreenLuminance();
}

template<> inline JSScreenLuminance* IDLAttribute<JSScreenLuminance>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSScreenLuminance*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsScreenLuminanceConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSScreenLuminancePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSScreenLuminance::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSScreenLuminanceConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSScreenLuminancePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsScreenLuminanceMinGetter(ExecState& state, JSScreenLuminance& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.min());
    return result;
}

EncodedJSValue jsScreenLuminanceMin(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSScreenLuminance>::get<jsScreenLuminanceMinGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "min");
}

static inline JSValue jsScreenLuminanceMaxGetter(ExecState& state, JSScreenLuminance& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.max());
    return result;
}

EncodedJSValue jsScreenLuminanceMax(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSScreenLuminance>::get<jsScreenLuminanceMaxGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "max");
}

static inline JSValue jsScreenLuminanceMaxAverageGetter(ExecState& state, JSScreenLuminance& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.maxAverage());
    return result;
}

EncodedJSValue jsScreenLuminanceMaxAverage(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSScreenLuminance>::get<jsScreenLuminanceMaxAverageGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "maxAverage");
}

void JSScreenLuminance::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSScreenLuminance*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSScreenLuminanceOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSScreenLuminanceOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsScreenLuminance = static_cast<JSScreenLuminance*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsScreenLuminance->wrapped(), jsScreenLuminance);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<ScreenLuminance>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to ScreenLuminance.
    static_assert(!std::is_polymorphic<ScreenLuminance>::value, "ScreenLuminance is polymorphic but the IDL claims it is not");
    return createWrapper<ScreenLuminance>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, ScreenLuminance& impl)
{
    return wrap(state, globalObject, impl);
}

ScreenLuminance* JSScreenLuminance::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSScreenLuminance*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
