/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSScrollToOptions.h"

#include "JSDOMConvertNumbers.h"
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> ScrollToOptions convertDictionary<ScrollToOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    ScrollToOptions result;
    JSValue leftValue;
    if (isNullOrUndefined)
        leftValue = jsUndefined();
    else {
        leftValue = object->get(&state, Identifier::fromString(&state, "left"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!leftValue.isUndefined()) {
        result.left = convert<IDLUnrestrictedDouble>(state, leftValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue topValue;
    if (isNullOrUndefined)
        topValue = jsUndefined();
    else {
        topValue = object->get(&state, Identifier::fromString(&state, "top"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!topValue.isUndefined()) {
        result.top = convert<IDLUnrestrictedDouble>(state, topValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

} // namespace WebCore
