/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSSpectreGadget.h"

#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsSpectreGadgetPrototypeFunctionSetReadLength(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsSpectreGadgetPrototypeFunctionCharCodeAt(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsSpectreGadgetPrototypeFunctionClflushReadLength(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsSpectreGadgetConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSSpectreGadgetConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSSpectreGadgetPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSSpectreGadgetPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSSpectreGadgetPrototype* ptr = new (NotNull, JSC::allocateCell<JSSpectreGadgetPrototype>(vm.heap)) JSSpectreGadgetPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSSpectreGadgetPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSSpectreGadgetConstructor = JSDOMConstructor<JSSpectreGadget>;

template<> EncodedJSValue JSC_HOST_CALL JSSpectreGadgetConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSSpectreGadgetConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto data = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = SpectreGadget::create(WTFMove(data));
    return JSValue::encode(toJSNewlyCreated<IDLInterface<SpectreGadget>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSSpectreGadgetConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSSpectreGadgetConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSSpectreGadget::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("SpectreGadget"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSSpectreGadgetConstructor::s_info = { "SpectreGadget", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSpectreGadgetConstructor) };

/* Hash table for prototype */

static const HashTableValue JSSpectreGadgetPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSpectreGadgetConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSSpectreGadgetConstructor) } },
    { "setReadLength", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsSpectreGadgetPrototypeFunctionSetReadLength), (intptr_t) (1) } },
    { "charCodeAt", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsSpectreGadgetPrototypeFunctionCharCodeAt), (intptr_t) (1) } },
    { "clflushReadLength", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsSpectreGadgetPrototypeFunctionClflushReadLength), (intptr_t) (0) } },
};

const ClassInfo JSSpectreGadgetPrototype::s_info = { "SpectreGadgetPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSpectreGadgetPrototype) };

void JSSpectreGadgetPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSSpectreGadget::info(), JSSpectreGadgetPrototypeTableValues, *this);
}

const ClassInfo JSSpectreGadget::s_info = { "SpectreGadget", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSSpectreGadget) };

JSSpectreGadget::JSSpectreGadget(Structure* structure, JSDOMGlobalObject& globalObject, Ref<SpectreGadget>&& impl)
    : JSDOMWrapper<SpectreGadget>(structure, globalObject, WTFMove(impl))
{
}

void JSSpectreGadget::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSSpectreGadget::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSSpectreGadgetPrototype::create(vm, &globalObject, JSSpectreGadgetPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSSpectreGadget::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSSpectreGadget>(vm, globalObject);
}

JSValue JSSpectreGadget::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSSpectreGadgetConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSSpectreGadget::destroy(JSC::JSCell* cell)
{
    JSSpectreGadget* thisObject = static_cast<JSSpectreGadget*>(cell);
    thisObject->JSSpectreGadget::~JSSpectreGadget();
}

template<> inline JSSpectreGadget* IDLOperation<JSSpectreGadget>::cast(ExecState& state)
{
    return jsDynamicCast<JSSpectreGadget*>(state.vm(), state.thisValue());
}

EncodedJSValue jsSpectreGadgetConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSSpectreGadgetPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSSpectreGadget::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSSpectreGadgetConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSSpectreGadgetPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsSpectreGadgetPrototypeFunctionSetReadLengthBody(JSC::ExecState* state, typename IDLOperation<JSSpectreGadget>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto readLength = convert<IDLUnsignedLong>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.setReadLength(WTFMove(readLength));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsSpectreGadgetPrototypeFunctionSetReadLength(ExecState* state)
{
    return IDLOperation<JSSpectreGadget>::call<jsSpectreGadgetPrototypeFunctionSetReadLengthBody>(*state, "setReadLength");
}

static inline JSC::EncodedJSValue jsSpectreGadgetPrototypeFunctionCharCodeAtBody(JSC::ExecState* state, typename IDLOperation<JSSpectreGadget>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto index = convert<IDLUnsignedLong>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLUnsignedLong>(impl.charCodeAt(WTFMove(index))));
}

EncodedJSValue JSC_HOST_CALL jsSpectreGadgetPrototypeFunctionCharCodeAt(ExecState* state)
{
    return IDLOperation<JSSpectreGadget>::call<jsSpectreGadgetPrototypeFunctionCharCodeAtBody>(*state, "charCodeAt");
}

static inline JSC::EncodedJSValue jsSpectreGadgetPrototypeFunctionClflushReadLengthBody(JSC::ExecState* state, typename IDLOperation<JSSpectreGadget>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.clflushReadLength();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsSpectreGadgetPrototypeFunctionClflushReadLength(ExecState* state)
{
    return IDLOperation<JSSpectreGadget>::call<jsSpectreGadgetPrototypeFunctionClflushReadLengthBody>(*state, "clflushReadLength");
}

void JSSpectreGadget::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSSpectreGadget*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSSpectreGadgetOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSSpectreGadgetOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsSpectreGadget = static_cast<JSSpectreGadget*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsSpectreGadget->wrapped(), jsSpectreGadget);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<SpectreGadget>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to SpectreGadget.
    static_assert(!std::is_polymorphic<SpectreGadget>::value, "SpectreGadget is polymorphic but the IDL claims it is not");
    return createWrapper<SpectreGadget>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, SpectreGadget& impl)
{
    return wrap(state, globalObject, impl);
}

SpectreGadget* JSSpectreGadget::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSSpectreGadget*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
