/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRDisplay.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertCallbacks.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSRequestAnimationFrameCallback.h"
#include "JSVRDisplayCapabilities.h"
#include "JSVREye.h"
#include "JSVREyeParameters.h"
#include "JSVRFrameData.h"
#include "JSVRLayerInit.h"
#include "JSVRPose.h"
#include "JSVRStageParameters.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetEyeParameters(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetFrameData(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetPose(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionResetPose(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestAnimationFrame(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionCancelAnimationFrame(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestPresent(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionExitPresent(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetLayers(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionSubmitFrame(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsVRDisplayConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRDisplayConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRDisplayIsConnected(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayIsPresenting(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayCapabilities(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayStageParameters(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayDisplayId(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayDisplayName(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRDisplayDepthNear(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRDisplayDepthNear(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRDisplayDepthFar(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRDisplayDepthFar(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSVRDisplayPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSVRDisplayPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSVRDisplayPrototype* ptr = new (NotNull, JSC::allocateCell<JSVRDisplayPrototype>(vm.heap)) JSVRDisplayPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSVRDisplayPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSVRDisplayConstructor = JSDOMConstructorNotConstructable<JSVRDisplay>;

template<> JSValue JSVRDisplayConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEventTarget::getConstructor(vm, &globalObject);
}

template<> void JSVRDisplayConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSVRDisplay::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("VRDisplay"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSVRDisplayConstructor::s_info = { "VRDisplay", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplayConstructor) };

/* Hash table for prototype */

static const HashTableValue JSVRDisplayPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRDisplayConstructor) } },
    { "isConnected", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayIsConnected), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "isPresenting", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayIsPresenting), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "capabilities", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayCapabilities), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "stageParameters", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayStageParameters), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "displayId", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDisplayId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "displayName", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDisplayName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "depthNear", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDepthNear), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRDisplayDepthNear) } },
    { "depthFar", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRDisplayDepthFar), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRDisplayDepthFar) } },
    { "getEyeParameters", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetEyeParameters), (intptr_t) (1) } },
    { "getFrameData", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetFrameData), (intptr_t) (1) } },
    { "getPose", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetPose), (intptr_t) (0) } },
    { "resetPose", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionResetPose), (intptr_t) (0) } },
    { "requestAnimationFrame", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionRequestAnimationFrame), (intptr_t) (1) } },
    { "cancelAnimationFrame", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionCancelAnimationFrame), (intptr_t) (1) } },
    { "requestPresent", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionRequestPresent), (intptr_t) (1) } },
    { "exitPresent", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionExitPresent), (intptr_t) (0) } },
    { "getLayers", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionGetLayers), (intptr_t) (0) } },
    { "submitFrame", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsVRDisplayPrototypeFunctionSubmitFrame), (intptr_t) (0) } },
};

const ClassInfo JSVRDisplayPrototype::s_info = { "VRDisplayPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplayPrototype) };

void JSVRDisplayPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSVRDisplay::info(), JSVRDisplayPrototypeTableValues, *this);
}

const ClassInfo JSVRDisplay::s_info = { "VRDisplay", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRDisplay) };

JSVRDisplay::JSVRDisplay(Structure* structure, JSDOMGlobalObject& globalObject, Ref<VRDisplay>&& impl)
    : JSEventTarget(structure, globalObject, WTFMove(impl))
{
}

void JSVRDisplay::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSVRDisplay::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSVRDisplayPrototype::create(vm, &globalObject, JSVRDisplayPrototype::createStructure(vm, &globalObject, JSEventTarget::prototype(vm, globalObject)));
}

JSObject* JSVRDisplay::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSVRDisplay>(vm, globalObject);
}

JSValue JSVRDisplay::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSVRDisplayConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSVRDisplay* IDLAttribute<JSVRDisplay>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSVRDisplay*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSVRDisplay* IDLOperation<JSVRDisplay>::cast(ExecState& state)
{
    return jsDynamicCast<JSVRDisplay*>(state.vm(), state.thisValue());
}

EncodedJSValue jsVRDisplayConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRDisplayPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSVRDisplay::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSVRDisplayConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRDisplayPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsVRDisplayIsConnectedGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.isConnected());
    return result;
}

EncodedJSValue jsVRDisplayIsConnected(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayIsConnectedGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "isConnected");
}

static inline JSValue jsVRDisplayIsPresentingGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.isPresenting());
    return result;
}

EncodedJSValue jsVRDisplayIsPresenting(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayIsPresentingGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "isPresenting");
}

static inline JSValue jsVRDisplayCapabilitiesGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<VRDisplayCapabilities>>(state, *thisObject.globalObject(), throwScope, impl.capabilities());
    return result;
}

EncodedJSValue jsVRDisplayCapabilities(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayCapabilitiesGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "capabilities");
}

static inline JSValue jsVRDisplayStageParametersGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<VRStageParameters>>>(state, *thisObject.globalObject(), throwScope, impl.stageParameters());
    return result;
}

EncodedJSValue jsVRDisplayStageParameters(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayStageParametersGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "stageParameters");
}

static inline JSValue jsVRDisplayDisplayIdGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(state, throwScope, impl.displayId());
    return result;
}

EncodedJSValue jsVRDisplayDisplayId(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDisplayIdGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "displayId");
}

static inline JSValue jsVRDisplayDisplayNameGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, throwScope, impl.displayName());
    return result;
}

EncodedJSValue jsVRDisplayDisplayName(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDisplayNameGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "displayName");
}

static inline JSValue jsVRDisplayDepthNearGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.depthNear());
    return result;
}

EncodedJSValue jsVRDisplayDepthNear(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDepthNearGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "depthNear");
}

static inline bool setJSVRDisplayDepthNearSetter(ExecState& state, JSVRDisplay& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setDepthNear(WTFMove(nativeValue));
    });
    return true;
}

bool setJSVRDisplayDepthNear(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSVRDisplay>::set<setJSVRDisplayDepthNearSetter>(*state, thisValue, encodedValue, "depthNear");
}

static inline JSValue jsVRDisplayDepthFarGetter(ExecState& state, JSVRDisplay& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.depthFar());
    return result;
}

EncodedJSValue jsVRDisplayDepthFar(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRDisplay>::get<jsVRDisplayDepthFarGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "depthFar");
}

static inline bool setJSVRDisplayDepthFarSetter(ExecState& state, JSVRDisplay& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setDepthFar(WTFMove(nativeValue));
    });
    return true;
}

bool setJSVRDisplayDepthFar(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSVRDisplay>::set<setJSVRDisplayDepthFarSetter>(*state, thisValue, encodedValue, "depthFar");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetEyeParametersBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto whichEye = convert<IDLEnumeration<VREye>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentMustBeEnumError(state, scope, 0, "whichEye", "VRDisplay", "getEyeParameters", expectedEnumerationValues<VREye>()); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLInterface<VREyeParameters>>(*state, *castedThis->globalObject(), impl.getEyeParameters(WTFMove(whichEye))));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetEyeParameters(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetEyeParametersBody>(*state, "getEyeParameters");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetFrameDataBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto frameData = convert<IDLInterface<VRFrameData>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "frameData", "VRDisplay", "getFrameData", "VRFrameData"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLBoolean>(impl.getFrameData(*frameData)));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetFrameData(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetFrameDataBody>(*state, "getFrameData");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetPoseBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJSNewlyCreated<IDLInterface<VRPose>>(*state, *castedThis->globalObject(), impl.getPose()));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetPose(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetPoseBody>(*state, "getPose");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionResetPoseBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.resetPose();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionResetPose(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionResetPoseBody>(*state, "resetPose");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionRequestAnimationFrameBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto callback = convert<IDLCallbackFunction<JSRequestAnimationFrameCallback>>(*state, state->uncheckedArgument(0), *castedThis->globalObject(), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentMustBeFunctionError(state, scope, 0, "callback", "VRDisplay", "requestAnimationFrame"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLLong>(impl.requestAnimationFrame(callback.releaseNonNull())));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestAnimationFrame(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionRequestAnimationFrameBody>(*state, "requestAnimationFrame");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionCancelAnimationFrameBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto handle = convert<IDLUnsignedLong>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.cancelAnimationFrame(WTFMove(handle));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionCancelAnimationFrame(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionCancelAnimationFrameBody>(*state, "cancelAnimationFrame");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionRequestPresentBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSVRDisplay>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto layers = convert<IDLSequence<IDLDictionary<VRLayerInit>>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.requestPresent(WTFMove(layers), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionRequestPresent(ExecState* state)
{
    return IDLOperationReturningPromise<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionRequestPresentBody, PromiseExecutionScope::WindowOnly>(*state, "requestPresent");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionExitPresentBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSVRDisplay>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.exitPresent(WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionExitPresent(ExecState* state)
{
    return IDLOperationReturningPromise<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionExitPresentBody, PromiseExecutionScope::WindowOnly>(*state, "exitPresent");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionGetLayersBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLSequence<IDLDictionary<VRLayerInit>>>(*state, *castedThis->globalObject(), impl.getLayers()));
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionGetLayers(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionGetLayersBody>(*state, "getLayers");
}

static inline JSC::EncodedJSValue jsVRDisplayPrototypeFunctionSubmitFrameBody(JSC::ExecState* state, typename IDLOperation<JSVRDisplay>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.submitFrame();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsVRDisplayPrototypeFunctionSubmitFrame(ExecState* state)
{
    return IDLOperation<JSVRDisplay>::call<jsVRDisplayPrototypeFunctionSubmitFrameBody>(*state, "submitFrame");
}

void JSVRDisplay::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSVRDisplay*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7VRDisplay@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore9VRDisplayE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<VRDisplay>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(__identifier("??_7VRDisplay@WebCore@@6B@"));
#else
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(&_ZTVN7WebCore9VRDisplayE[2]);
#endif

    // If this fails VRDisplay does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<VRDisplay>::value, "VRDisplay is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // VRDisplay has subclasses. If VRDisplay has subclasses that get passed
    // to toJS() we currently require VRDisplay you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<VRDisplay>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, VRDisplay& impl)
{
    return wrap(state, globalObject, impl);
}

VRDisplay* JSVRDisplay::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSVRDisplay*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
