/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRDisplayEventReason.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(VRDisplayEventReason enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("mounted"),
        MAKE_STATIC_STRING_IMPL("navigation"),
        MAKE_STATIC_STRING_IMPL("requested"),
        MAKE_STATIC_STRING_IMPL("unmounted"),
    };
    static_assert(static_cast<size_t>(VRDisplayEventReason::Mounted) == 0, "VRDisplayEventReason::Mounted is not 0 as expected");
    static_assert(static_cast<size_t>(VRDisplayEventReason::Navigation) == 1, "VRDisplayEventReason::Navigation is not 1 as expected");
    static_assert(static_cast<size_t>(VRDisplayEventReason::Requested) == 2, "VRDisplayEventReason::Requested is not 2 as expected");
    static_assert(static_cast<size_t>(VRDisplayEventReason::Unmounted) == 3, "VRDisplayEventReason::Unmounted is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(ExecState& state, VRDisplayEventReason enumerationValue)
{
    return jsStringWithCache(&state, convertEnumerationToString(enumerationValue));
}

template<> Optional<VRDisplayEventReason> parseEnumeration<VRDisplayEventReason>(ExecState& state, JSValue value)
{
    auto stringValue = value.toWTFString(&state);
    if (stringValue == "mounted")
        return VRDisplayEventReason::Mounted;
    if (stringValue == "navigation")
        return VRDisplayEventReason::Navigation;
    if (stringValue == "requested")
        return VRDisplayEventReason::Requested;
    if (stringValue == "unmounted")
        return VRDisplayEventReason::Unmounted;
    return WTF::nullopt;
}

template<> const char* expectedEnumerationValues<VRDisplayEventReason>()
{
    return "\"mounted\", \"navigation\", \"requested\", \"unmounted\"";
}

} // namespace WebCore
