/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRPose.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsVRPoseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRPoseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRPosePosition(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRPoseLinearVelocity(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRPoseLinearAcceleration(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRPoseOrientation(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRPoseAngularVelocity(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRPoseAngularAcceleration(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSVRPosePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSVRPosePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSVRPosePrototype* ptr = new (NotNull, JSC::allocateCell<JSVRPosePrototype>(vm.heap)) JSVRPosePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSVRPosePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSVRPoseConstructor = JSDOMConstructorNotConstructable<JSVRPose>;

template<> JSValue JSVRPoseConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSVRPoseConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSVRPose::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("VRPose"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSVRPoseConstructor::s_info = { "VRPose", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRPoseConstructor) };

/* Hash table for prototype */

static const HashTableValue JSVRPosePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRPoseConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRPoseConstructor) } },
    { "position", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRPosePosition), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "linearVelocity", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRPoseLinearVelocity), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "linearAcceleration", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRPoseLinearAcceleration), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "orientation", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRPoseOrientation), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "angularVelocity", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRPoseAngularVelocity), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "angularAcceleration", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRPoseAngularAcceleration), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSVRPosePrototype::s_info = { "VRPosePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRPosePrototype) };

void JSVRPosePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSVRPose::info(), JSVRPosePrototypeTableValues, *this);
}

const ClassInfo JSVRPose::s_info = { "VRPose", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRPose) };

JSVRPose::JSVRPose(Structure* structure, JSDOMGlobalObject& globalObject, Ref<VRPose>&& impl)
    : JSDOMWrapper<VRPose>(structure, globalObject, WTFMove(impl))
{
}

void JSVRPose::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSVRPose::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSVRPosePrototype::create(vm, &globalObject, JSVRPosePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSVRPose::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSVRPose>(vm, globalObject);
}

JSValue JSVRPose::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSVRPoseConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSVRPose::destroy(JSC::JSCell* cell)
{
    JSVRPose* thisObject = static_cast<JSVRPose*>(cell);
    thisObject->JSVRPose::~JSVRPose();
}

template<> inline JSVRPose* IDLAttribute<JSVRPose>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSVRPose*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsVRPoseConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRPosePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSVRPose::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSVRPoseConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRPosePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsVRPosePositionGetter(ExecState& state, JSVRPose& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLFloat32Array>>(state, *thisObject.globalObject(), throwScope, impl.position());
    return result;
}

EncodedJSValue jsVRPosePosition(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRPose>::get<jsVRPosePositionGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "position");
}

static inline JSValue jsVRPoseLinearVelocityGetter(ExecState& state, JSVRPose& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLFloat32Array>>(state, *thisObject.globalObject(), throwScope, impl.linearVelocity());
    return result;
}

EncodedJSValue jsVRPoseLinearVelocity(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRPose>::get<jsVRPoseLinearVelocityGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "linearVelocity");
}

static inline JSValue jsVRPoseLinearAccelerationGetter(ExecState& state, JSVRPose& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLFloat32Array>>(state, *thisObject.globalObject(), throwScope, impl.linearAcceleration());
    return result;
}

EncodedJSValue jsVRPoseLinearAcceleration(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRPose>::get<jsVRPoseLinearAccelerationGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "linearAcceleration");
}

static inline JSValue jsVRPoseOrientationGetter(ExecState& state, JSVRPose& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLFloat32Array>>(state, *thisObject.globalObject(), throwScope, impl.orientation());
    return result;
}

EncodedJSValue jsVRPoseOrientation(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRPose>::get<jsVRPoseOrientationGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "orientation");
}

static inline JSValue jsVRPoseAngularVelocityGetter(ExecState& state, JSVRPose& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLFloat32Array>>(state, *thisObject.globalObject(), throwScope, impl.angularVelocity());
    return result;
}

EncodedJSValue jsVRPoseAngularVelocity(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRPose>::get<jsVRPoseAngularVelocityGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "angularVelocity");
}

static inline JSValue jsVRPoseAngularAccelerationGetter(ExecState& state, JSVRPose& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLFloat32Array>>(state, *thisObject.globalObject(), throwScope, impl.angularAcceleration());
    return result;
}

EncodedJSValue jsVRPoseAngularAcceleration(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRPose>::get<jsVRPoseAngularAccelerationGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "angularAcceleration");
}

void JSVRPose::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSVRPose*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSVRPoseOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSVRPoseOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsVRPose = static_cast<JSVRPose*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsVRPose->wrapped(), jsVRPose);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<VRPose>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to VRPose.
    static_assert(!std::is_polymorphic<VRPose>::value, "VRPose is polymorphic but the IDL claims it is not");
    return createWrapper<VRPose>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, VRPose& impl)
{
    return wrap(state, globalObject, impl);
}

VRPose* JSVRPose::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSVRPose*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
