/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRStageParameters.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsVRStageParametersConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSVRStageParametersConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsVRStageParametersSittingToStandingTransform(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRStageParametersSizeX(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsVRStageParametersSizeZ(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSVRStageParametersPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSVRStageParametersPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSVRStageParametersPrototype* ptr = new (NotNull, JSC::allocateCell<JSVRStageParametersPrototype>(vm.heap)) JSVRStageParametersPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSVRStageParametersPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSVRStageParametersConstructor = JSDOMConstructorNotConstructable<JSVRStageParameters>;

template<> JSValue JSVRStageParametersConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSVRStageParametersConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSVRStageParameters::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("VRStageParameters"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSVRStageParametersConstructor::s_info = { "VRStageParameters", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRStageParametersConstructor) };

/* Hash table for prototype */

static const HashTableValue JSVRStageParametersPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRStageParametersConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSVRStageParametersConstructor) } },
    { "sittingToStandingTransform", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRStageParametersSittingToStandingTransform), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "sizeX", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRStageParametersSizeX), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "sizeZ", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsVRStageParametersSizeZ), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSVRStageParametersPrototype::s_info = { "VRStageParametersPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRStageParametersPrototype) };

void JSVRStageParametersPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSVRStageParameters::info(), JSVRStageParametersPrototypeTableValues, *this);
}

const ClassInfo JSVRStageParameters::s_info = { "VRStageParameters", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSVRStageParameters) };

JSVRStageParameters::JSVRStageParameters(Structure* structure, JSDOMGlobalObject& globalObject, Ref<VRStageParameters>&& impl)
    : JSDOMWrapper<VRStageParameters>(structure, globalObject, WTFMove(impl))
{
}

void JSVRStageParameters::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSVRStageParameters::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSVRStageParametersPrototype::create(vm, &globalObject, JSVRStageParametersPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSVRStageParameters::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSVRStageParameters>(vm, globalObject);
}

JSValue JSVRStageParameters::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSVRStageParametersConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSVRStageParameters::destroy(JSC::JSCell* cell)
{
    JSVRStageParameters* thisObject = static_cast<JSVRStageParameters*>(cell);
    thisObject->JSVRStageParameters::~JSVRStageParameters();
}

template<> inline JSVRStageParameters* IDLAttribute<JSVRStageParameters>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSVRStageParameters*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsVRStageParametersConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRStageParametersPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSVRStageParameters::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSVRStageParametersConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSVRStageParametersPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsVRStageParametersSittingToStandingTransformGetter(ExecState& state, JSVRStageParameters& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat32Array>(state, *thisObject.globalObject(), throwScope, impl.sittingToStandingTransform());
    return result;
}

EncodedJSValue jsVRStageParametersSittingToStandingTransform(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRStageParameters>::get<jsVRStageParametersSittingToStandingTransformGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "sittingToStandingTransform");
}

static inline JSValue jsVRStageParametersSizeXGetter(ExecState& state, JSVRStageParameters& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat>(state, throwScope, impl.sizeX());
    return result;
}

EncodedJSValue jsVRStageParametersSizeX(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRStageParameters>::get<jsVRStageParametersSizeXGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "sizeX");
}

static inline JSValue jsVRStageParametersSizeZGetter(ExecState& state, JSVRStageParameters& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLFloat>(state, throwScope, impl.sizeZ());
    return result;
}

EncodedJSValue jsVRStageParametersSizeZ(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSVRStageParameters>::get<jsVRStageParametersSizeZGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "sizeZ");
}

void JSVRStageParameters::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSVRStageParameters*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSVRStageParametersOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSVRStageParametersOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsVRStageParameters = static_cast<JSVRStageParameters*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsVRStageParameters->wrapped(), jsVRStageParameters);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<VRStageParameters>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to VRStageParameters.
    static_assert(!std::is_polymorphic<VRStageParameters>::value, "VRStageParameters is polymorphic but the IDL claims it is not");
    return createWrapper<VRStageParameters>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, VRStageParameters& impl)
{
    return wrap(state, globalObject, impl);
}

VRStageParameters* JSVRStageParameters::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSVRStageParameters*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
