/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSWebAnimation.h"

#include "DOMPromiseProxy.h"
#include "EventNames.h"
#include "JSAnimationEffect.h"
#include "JSAnimationTimeline.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertPromise.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSEventListener.h"
#include "JSWebAnimation.h"
#include "ScriptExecutionContext.h"
#include <JavaScriptCore/HeapSnapshotBuilder.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(WebAnimation::PlayState enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("idle"),
        MAKE_STATIC_STRING_IMPL("running"),
        MAKE_STATIC_STRING_IMPL("paused"),
        MAKE_STATIC_STRING_IMPL("finished"),
    };
    static_assert(static_cast<size_t>(WebAnimation::PlayState::Idle) == 0, "WebAnimation::PlayState::Idle is not 0 as expected");
    static_assert(static_cast<size_t>(WebAnimation::PlayState::Running) == 1, "WebAnimation::PlayState::Running is not 1 as expected");
    static_assert(static_cast<size_t>(WebAnimation::PlayState::Paused) == 2, "WebAnimation::PlayState::Paused is not 2 as expected");
    static_assert(static_cast<size_t>(WebAnimation::PlayState::Finished) == 3, "WebAnimation::PlayState::Finished is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(ExecState& state, WebAnimation::PlayState enumerationValue)
{
    return jsStringWithCache(&state, convertEnumerationToString(enumerationValue));
}

template<> Optional<WebAnimation::PlayState> parseEnumeration<WebAnimation::PlayState>(ExecState& state, JSValue value)
{
    auto stringValue = value.toWTFString(&state);
    if (stringValue == "idle")
        return WebAnimation::PlayState::Idle;
    if (stringValue == "running")
        return WebAnimation::PlayState::Running;
    if (stringValue == "paused")
        return WebAnimation::PlayState::Paused;
    if (stringValue == "finished")
        return WebAnimation::PlayState::Finished;
    return WTF::nullopt;
}

template<> const char* expectedEnumerationValues<WebAnimation::PlayState>()
{
    return "\"idle\", \"running\", \"paused\", \"finished\"";
}

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionCancel(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionFinish(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionPlay(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionPause(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionUpdatePlaybackRate(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionReverse(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsWebAnimationConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationId(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationId(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationEffect(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationEffect(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationTimeline(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationTimeline(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationStartTime(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationStartTime(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationCurrentTime(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationCurrentTime(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationPlaybackRate(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationPlaybackRate(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationPlayState(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsWebAnimationPending(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsWebAnimationOnfinish(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationOnfinish(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationOncancel(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSWebAnimationOncancel(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsWebAnimationReady(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsWebAnimationFinished(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSWebAnimationPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebAnimationPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebAnimationPrototype* ptr = new (NotNull, JSC::allocateCell<JSWebAnimationPrototype>(vm.heap)) JSWebAnimationPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebAnimationPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSWebAnimationConstructor = JSDOMConstructor<JSWebAnimation>;

template<> JSC::EncodedJSValue JSC_HOST_CALL JSWebAnimationConstructor::construct(JSC::ExecState* exec)
{
    ASSERT(exec);
    return constructJSWebAnimation(*exec);
}

template<> JSValue JSWebAnimationConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEventTarget::getConstructor(vm, &globalObject);
}

template<> void JSWebAnimationConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSWebAnimation::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("Animation"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSWebAnimationConstructor::s_info = { "Animation", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebAnimationConstructor) };

/* Hash table for prototype */

static const HashTableValue JSWebAnimationPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationConstructor) } },
    { "id", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationId) } },
    { "effect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationEffect), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationEffect) } },
    { "timeline", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationTimeline), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationTimeline) } },
    { "startTime", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationStartTime), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationStartTime) } },
    { "currentTime", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationCurrentTime), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationCurrentTime) } },
    { "playbackRate", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationPlaybackRate), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationPlaybackRate) } },
    { "playState", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationPlayState), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "pending", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationPending), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "onfinish", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationOnfinish), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationOnfinish) } },
    { "oncancel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationOncancel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSWebAnimationOncancel) } },
    { "ready", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationReady), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "finished", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsWebAnimationFinished), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "cancel", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebAnimationPrototypeFunctionCancel), (intptr_t) (0) } },
    { "finish", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebAnimationPrototypeFunctionFinish), (intptr_t) (0) } },
    { "play", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebAnimationPrototypeFunctionPlay), (intptr_t) (0) } },
    { "pause", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebAnimationPrototypeFunctionPause), (intptr_t) (0) } },
    { "updatePlaybackRate", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebAnimationPrototypeFunctionUpdatePlaybackRate), (intptr_t) (1) } },
    { "reverse", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsWebAnimationPrototypeFunctionReverse), (intptr_t) (0) } },
};

const ClassInfo JSWebAnimationPrototype::s_info = { "AnimationPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebAnimationPrototype) };

void JSWebAnimationPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSWebAnimation::info(), JSWebAnimationPrototypeTableValues, *this);
}

const ClassInfo JSWebAnimation::s_info = { "Animation", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebAnimation) };

JSWebAnimation::JSWebAnimation(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebAnimation>&& impl)
    : JSEventTarget(structure, globalObject, WTFMove(impl))
{
}

void JSWebAnimation::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSWebAnimation::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSWebAnimationPrototype::create(vm, &globalObject, JSWebAnimationPrototype::createStructure(vm, &globalObject, JSEventTarget::prototype(vm, globalObject)));
}

JSObject* JSWebAnimation::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebAnimation>(vm, globalObject);
}

JSValue JSWebAnimation::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSWebAnimationConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSWebAnimation* IDLAttribute<JSWebAnimation>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSWebAnimation*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSWebAnimation* IDLOperation<JSWebAnimation>::cast(ExecState& state)
{
    return jsDynamicCast<JSWebAnimation*>(state.vm(), state.thisValue());
}

EncodedJSValue jsWebAnimationConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebAnimationPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSWebAnimation::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSWebAnimationConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSWebAnimationPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsWebAnimationIdGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, throwScope, impl.id());
    return result;
}

EncodedJSValue jsWebAnimationId(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationIdGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "id");
}

static inline bool setJSWebAnimationIdSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDOMString>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setId(WTFMove(nativeValue));
    });
    return true;
}

bool setJSWebAnimationId(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationIdSetter>(*state, thisValue, encodedValue, "id");
}

static inline JSValue jsWebAnimationEffectGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<AnimationEffect>>>(state, *thisObject.globalObject(), throwScope, impl.effect());
    return result;
}

EncodedJSValue jsWebAnimationEffect(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationEffectGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "effect");
}

static inline bool setJSWebAnimationEffectSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLNullable<IDLInterface<AnimationEffect>>>(state, value, [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwAttributeTypeError(state, scope, "Animation", "effect", "AnimationEffect"); });
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setEffect(WTFMove(nativeValue));
    });
    return true;
}

bool setJSWebAnimationEffect(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationEffectSetter>(*state, thisValue, encodedValue, "effect");
}

static inline JSValue jsWebAnimationTimelineGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<AnimationTimeline>>>(state, *thisObject.globalObject(), throwScope, impl.timeline());
    return result;
}

EncodedJSValue jsWebAnimationTimeline(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationTimelineGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "timeline");
}

static inline bool setJSWebAnimationTimelineSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLNullable<IDLInterface<AnimationTimeline>>>(state, value, [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwAttributeTypeError(state, scope, "Animation", "timeline", "AnimationTimeline"); });
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setTimeline(WTFMove(nativeValue));
    });
    return true;
}

bool setJSWebAnimationTimeline(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationTimelineSetter>(*state, thisValue, encodedValue, "timeline");
}

static inline JSValue jsWebAnimationStartTimeGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLDouble>>(state, throwScope, impl.startTime());
    return result;
}

EncodedJSValue jsWebAnimationStartTime(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationStartTimeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "startTime");
}

static inline bool setJSWebAnimationStartTimeSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLNullable<IDLDouble>>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setStartTime(WTFMove(nativeValue));
    });
    return true;
}

bool setJSWebAnimationStartTime(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationStartTimeSetter>(*state, thisValue, encodedValue, "startTime");
}

static inline JSValue jsWebAnimationCurrentTimeGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLDouble>>(state, throwScope, impl.bindingsCurrentTime());
    return result;
}

EncodedJSValue jsWebAnimationCurrentTime(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationCurrentTimeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "currentTime");
}

static inline bool setJSWebAnimationCurrentTimeSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLNullable<IDLDouble>>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setBindingsCurrentTime(WTFMove(nativeValue));
    });
    return true;
}

bool setJSWebAnimationCurrentTime(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationCurrentTimeSetter>(*state, thisValue, encodedValue, "currentTime");
}

static inline JSValue jsWebAnimationPlaybackRateGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDouble>(state, throwScope, impl.playbackRate());
    return result;
}

EncodedJSValue jsWebAnimationPlaybackRate(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationPlaybackRateGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "playbackRate");
}

static inline bool setJSWebAnimationPlaybackRateSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLDouble>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setPlaybackRate(WTFMove(nativeValue));
    });
    return true;
}

bool setJSWebAnimationPlaybackRate(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationPlaybackRateSetter>(*state, thisValue, encodedValue, "playbackRate");
}

static inline JSValue jsWebAnimationPlayStateGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLEnumeration<WebAnimation::PlayState>>(state, throwScope, impl.bindingsPlayState());
    return result;
}

EncodedJSValue jsWebAnimationPlayState(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationPlayStateGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "playState");
}

static inline JSValue jsWebAnimationPendingGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(state, throwScope, impl.bindingsPending());
    return result;
}

EncodedJSValue jsWebAnimationPending(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationPendingGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "pending");
}

static inline JSValue jsWebAnimationOnfinishGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().finishEvent, worldForDOMObject(thisObject));
}

EncodedJSValue jsWebAnimationOnfinish(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationOnfinishGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "onfinish");
}

static inline bool setJSWebAnimationOnfinishSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    setEventHandlerAttribute(state, thisObject, thisObject.wrapped(), eventNames().finishEvent, value);
    return true;
}

bool setJSWebAnimationOnfinish(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationOnfinishSetter>(*state, thisValue, encodedValue, "onfinish");
}

static inline JSValue jsWebAnimationOncancelGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().cancelEvent, worldForDOMObject(thisObject));
}

EncodedJSValue jsWebAnimationOncancel(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationOncancelGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "oncancel");
}

static inline bool setJSWebAnimationOncancelSetter(ExecState& state, JSWebAnimation& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    setEventHandlerAttribute(state, thisObject, thisObject.wrapped(), eventNames().cancelEvent, value);
    return true;
}

bool setJSWebAnimationOncancel(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSWebAnimation>::set<setJSWebAnimationOncancelSetter>(*state, thisValue, encodedValue, "oncancel");
}

static inline JSValue jsWebAnimationReadyGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLPromise<IDLInterface<WebAnimation>>>(state, *thisObject.globalObject(), throwScope, impl.bindingsReady());
    return result;
}

EncodedJSValue jsWebAnimationReady(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationReadyGetter, CastedThisErrorBehavior::RejectPromise>(*state, thisValue, "ready");
}

static inline JSValue jsWebAnimationFinishedGetter(ExecState& state, JSWebAnimation& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLPromise<IDLInterface<WebAnimation>>>(state, *thisObject.globalObject(), throwScope, impl.bindingsFinished());
    return result;
}

EncodedJSValue jsWebAnimationFinished(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSWebAnimation>::get<jsWebAnimationFinishedGetter, CastedThisErrorBehavior::RejectPromise>(*state, thisValue, "finished");
}

static inline JSC::EncodedJSValue jsWebAnimationPrototypeFunctionCancelBody(JSC::ExecState* state, typename IDLOperation<JSWebAnimation>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.cancel();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionCancel(ExecState* state)
{
    return IDLOperation<JSWebAnimation>::call<jsWebAnimationPrototypeFunctionCancelBody>(*state, "cancel");
}

static inline JSC::EncodedJSValue jsWebAnimationPrototypeFunctionFinishBody(JSC::ExecState* state, typename IDLOperation<JSWebAnimation>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    propagateException(*state, throwScope, impl.finish());
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionFinish(ExecState* state)
{
    return IDLOperation<JSWebAnimation>::call<jsWebAnimationPrototypeFunctionFinishBody>(*state, "finish");
}

static inline JSC::EncodedJSValue jsWebAnimationPrototypeFunctionPlayBody(JSC::ExecState* state, typename IDLOperation<JSWebAnimation>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    propagateException(*state, throwScope, impl.bindingsPlay());
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionPlay(ExecState* state)
{
    return IDLOperation<JSWebAnimation>::call<jsWebAnimationPrototypeFunctionPlayBody>(*state, "play");
}

static inline JSC::EncodedJSValue jsWebAnimationPrototypeFunctionPauseBody(JSC::ExecState* state, typename IDLOperation<JSWebAnimation>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    propagateException(*state, throwScope, impl.bindingsPause());
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionPause(ExecState* state)
{
    return IDLOperation<JSWebAnimation>::call<jsWebAnimationPrototypeFunctionPauseBody>(*state, "pause");
}

static inline JSC::EncodedJSValue jsWebAnimationPrototypeFunctionUpdatePlaybackRateBody(JSC::ExecState* state, typename IDLOperation<JSWebAnimation>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto playbackRate = convert<IDLDouble>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.updatePlaybackRate(WTFMove(playbackRate));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionUpdatePlaybackRate(ExecState* state)
{
    return IDLOperation<JSWebAnimation>::call<jsWebAnimationPrototypeFunctionUpdatePlaybackRateBody>(*state, "updatePlaybackRate");
}

static inline JSC::EncodedJSValue jsWebAnimationPrototypeFunctionReverseBody(JSC::ExecState* state, typename IDLOperation<JSWebAnimation>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    propagateException(*state, throwScope, impl.reverse());
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsWebAnimationPrototypeFunctionReverse(ExecState* state)
{
    return IDLOperation<JSWebAnimation>::call<jsWebAnimationPrototypeFunctionReverseBody>(*state, "reverse");
}

void JSWebAnimation::heapSnapshot(JSCell* cell, HeapSnapshotBuilder& builder)
{
    auto* thisObject = jsCast<JSWebAnimation*>(cell);
    builder.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        builder.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::heapSnapshot(cell, builder);
}

bool JSWebAnimationOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor, const char** reason)
{
    auto* jsWebAnimation = jsCast<JSWebAnimation*>(handle.slot()->asCell());
    if (jsWebAnimation->wrapped().hasPendingActivity()) {
        if (UNLIKELY(reason))
            *reason = "ActiveDOMObject with pending activity";
        return true;
     }
    if (jsWebAnimation->wrapped().isFiringEventListeners()) {
        if (UNLIKELY(reason))
            *reason = "EventTarget firing event listeners";
        return true;
    }
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSWebAnimationOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsWebAnimation = static_cast<JSWebAnimation*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsWebAnimation->wrapped(), jsWebAnimation);
}

WebAnimation* JSWebAnimation::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebAnimation*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
