/*
 * Copyright (C) 2013 Google Inc. All rights reserved.
 * Copyright (C) 2013-2016 Apple Inc. All rights reserved.
 * Copyright (C) 2014 University of Washington. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

// DO NOT EDIT THIS FILE. It is automatically generated from Automation.json
// by the script: Source/JavaScriptCore/inspector/scripts/generate-inspector-protocol-bindings.py

#pragma once

#include "AutomationProtocolObjects.h"
#include <JavaScriptCore/InspectorBackendDispatcher.h>
#include <wtf/text/WTFString.h>

namespace Inspector {

typedef String ErrorString;

class AutomationBackendDispatcherHandler {
public:
    class GetBrowsingContextsCallback : public BackendDispatcher::CallbackBase {
    public:
        GetBrowsingContextsCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(RefPtr<JSON::ArrayOf<Inspector::Protocol::Automation::BrowsingContext>>&& contexts);
    };
    virtual void getBrowsingContexts(Ref<GetBrowsingContextsCallback>&& callback) = 0;
    class GetBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        GetBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(RefPtr<Inspector::Protocol::Automation::BrowsingContext>&& context);
    };
    virtual void getBrowsingContext(const String& in_handle, Ref<GetBrowsingContextCallback>&& callback) = 0;
    class CreateBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        CreateBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(const String& handle, Inspector::Protocol::Automation::BrowsingContextPresentation presentation);
    };
    virtual void createBrowsingContext(const String* opt_in_presentationHint, Ref<CreateBrowsingContextCallback>&& callback) = 0;
    virtual void closeBrowsingContext(ErrorString&, const String& in_handle) = 0;
    class SwitchToBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        SwitchToBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void switchToBrowsingContext(const String& in_browsingContextHandle, const String* opt_in_frameHandle, Ref<SwitchToBrowsingContextCallback>&& callback) = 0;
    class SetWindowFrameOfBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        SetWindowFrameOfBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void setWindowFrameOfBrowsingContext(const String& in_handle, const JSON::Object* opt_in_origin, const JSON::Object* opt_in_size, Ref<SetWindowFrameOfBrowsingContextCallback>&& callback) = 0;
    class MaximizeWindowOfBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        MaximizeWindowOfBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void maximizeWindowOfBrowsingContext(const String& in_handle, Ref<MaximizeWindowOfBrowsingContextCallback>&& callback) = 0;
    class HideWindowOfBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        HideWindowOfBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void hideWindowOfBrowsingContext(const String& in_handle, Ref<HideWindowOfBrowsingContextCallback>&& callback) = 0;
    class NavigateBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        NavigateBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void navigateBrowsingContext(const String& in_handle, const String& in_url, const String* opt_in_pageLoadStrategy, const int* opt_in_pageLoadTimeout, Ref<NavigateBrowsingContextCallback>&& callback) = 0;
    class GoBackInBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        GoBackInBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void goBackInBrowsingContext(const String& in_handle, const String* opt_in_pageLoadStrategy, const int* opt_in_pageLoadTimeout, Ref<GoBackInBrowsingContextCallback>&& callback) = 0;
    class GoForwardInBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        GoForwardInBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void goForwardInBrowsingContext(const String& in_handle, const String* opt_in_pageLoadStrategy, const int* opt_in_pageLoadTimeout, Ref<GoForwardInBrowsingContextCallback>&& callback) = 0;
    class ReloadBrowsingContextCallback : public BackendDispatcher::CallbackBase {
    public:
        ReloadBrowsingContextCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void reloadBrowsingContext(const String& in_handle, const String* opt_in_pageLoadStrategy, const int* opt_in_pageLoadTimeout, Ref<ReloadBrowsingContextCallback>&& callback) = 0;
    class WaitForNavigationToCompleteCallback : public BackendDispatcher::CallbackBase {
    public:
        WaitForNavigationToCompleteCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void waitForNavigationToComplete(const String& in_browsingContextHandle, const String* opt_in_frameHandle, const String* opt_in_pageLoadStrategy, const int* opt_in_pageLoadTimeout, Ref<WaitForNavigationToCompleteCallback>&& callback) = 0;
    class EvaluateJavaScriptFunctionCallback : public BackendDispatcher::CallbackBase {
    public:
        EvaluateJavaScriptFunctionCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(const String& result);
    };
    virtual void evaluateJavaScriptFunction(const String& in_browsingContextHandle, const String* opt_in_frameHandle, const String& in_function, const JSON::Array& in_arguments, const bool* opt_in_expectsImplicitCallbackArgument, const int* opt_in_callbackTimeout, Ref<EvaluateJavaScriptFunctionCallback>&& callback) = 0;
    class PerformMouseInteractionCallback : public BackendDispatcher::CallbackBase {
    public:
        PerformMouseInteractionCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(RefPtr<Inspector::Protocol::Automation::Point>&& position);
    };
    virtual void performMouseInteraction(const String& in_handle, const JSON::Object& in_position, const String& in_button, const String& in_interaction, const JSON::Array& in_modifiers, Ref<PerformMouseInteractionCallback>&& callback) = 0;
    class PerformKeyboardInteractionsCallback : public BackendDispatcher::CallbackBase {
    public:
        PerformKeyboardInteractionsCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void performKeyboardInteractions(const String& in_handle, const JSON::Array& in_interactions, Ref<PerformKeyboardInteractionsCallback>&& callback) = 0;
    class PerformInteractionSequenceCallback : public BackendDispatcher::CallbackBase {
    public:
        PerformInteractionSequenceCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void performInteractionSequence(const String& in_handle, const String* opt_in_frameHandle, const JSON::Array& in_inputSources, const JSON::Array& in_steps, Ref<PerformInteractionSequenceCallback>&& callback) = 0;
    class CancelInteractionSequenceCallback : public BackendDispatcher::CallbackBase {
    public:
        CancelInteractionSequenceCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void cancelInteractionSequence(const String& in_handle, const String* opt_in_frameHandle, Ref<CancelInteractionSequenceCallback>&& callback) = 0;
    class TakeScreenshotCallback : public BackendDispatcher::CallbackBase {
    public:
        TakeScreenshotCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(const String& data);
    };
    virtual void takeScreenshot(const String& in_handle, const String* opt_in_frameHandle, const String* opt_in_nodeHandle, const bool* opt_in_scrollIntoViewIfNeeded, const bool* opt_in_clipToViewport, Ref<TakeScreenshotCallback>&& callback) = 0;
    class ResolveChildFrameHandleCallback : public BackendDispatcher::CallbackBase {
    public:
        ResolveChildFrameHandleCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(const String& result);
    };
    virtual void resolveChildFrameHandle(const String& in_browsingContextHandle, const String* opt_in_frameHandle, const int* opt_in_ordinal, const String* opt_in_name, const String* opt_in_nodeHandle, Ref<ResolveChildFrameHandleCallback>&& callback) = 0;
    class ResolveParentFrameHandleCallback : public BackendDispatcher::CallbackBase {
    public:
        ResolveParentFrameHandleCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(const String& result);
    };
    virtual void resolveParentFrameHandle(const String& in_browsingContextHandle, const String& in_frameHandle, Ref<ResolveParentFrameHandleCallback>&& callback) = 0;
    class ComputeElementLayoutCallback : public BackendDispatcher::CallbackBase {
    public:
        ComputeElementLayoutCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(RefPtr<Inspector::Protocol::Automation::Rect>&& rect, RefPtr<Inspector::Protocol::Automation::Point>&& inViewCenterPoint, bool isObscured);
    };
    virtual void computeElementLayout(const String& in_browsingContextHandle, const String& in_frameHandle, const String& in_nodeHandle, const bool* opt_in_scrollIntoViewIfNeeded, const String& in_coordinateSystem, Ref<ComputeElementLayoutCallback>&& callback) = 0;
    class SelectOptionElementCallback : public BackendDispatcher::CallbackBase {
    public:
        SelectOptionElementCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void selectOptionElement(const String& in_browsingContextHandle, const String& in_frameHandle, const String& in_nodeHandle, Ref<SelectOptionElementCallback>&& callback) = 0;
    virtual void isShowingJavaScriptDialog(ErrorString&, const String& in_browsingContextHandle, bool* out_result) = 0;
    virtual void dismissCurrentJavaScriptDialog(ErrorString&, const String& in_browsingContextHandle) = 0;
    virtual void acceptCurrentJavaScriptDialog(ErrorString&, const String& in_browsingContextHandle) = 0;
    virtual void messageOfCurrentJavaScriptDialog(ErrorString&, const String& in_browsingContextHandle, String* out_message) = 0;
    virtual void setUserInputForCurrentJavaScriptPrompt(ErrorString&, const String& in_browsingContextHandle, const String& in_userInput) = 0;
    virtual void setFilesToSelectForFileUpload(ErrorString&, const String& in_browsingContextHandle, const JSON::Array& in_filenames) = 0;
    class GetAllCookiesCallback : public BackendDispatcher::CallbackBase {
    public:
        GetAllCookiesCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess(RefPtr<JSON::ArrayOf<Inspector::Protocol::Automation::Cookie>>&& cookies);
    };
    virtual void getAllCookies(const String& in_browsingContextHandle, Ref<GetAllCookiesCallback>&& callback) = 0;
    class DeleteSingleCookieCallback : public BackendDispatcher::CallbackBase {
    public:
        DeleteSingleCookieCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void deleteSingleCookie(const String& in_browsingContextHandle, const String& in_cookieName, Ref<DeleteSingleCookieCallback>&& callback) = 0;
    class AddSingleCookieCallback : public BackendDispatcher::CallbackBase {
    public:
        AddSingleCookieCallback(Ref<BackendDispatcher>&&, int id);
        void sendSuccess();
    };
    virtual void addSingleCookie(const String& in_browsingContextHandle, const JSON::Object& in_cookie, Ref<AddSingleCookieCallback>&& callback) = 0;
    virtual void deleteAllCookies(ErrorString&, const String& in_browsingContextHandle) = 0;
    virtual void getSessionPermissions(ErrorString&, RefPtr<JSON::ArrayOf<Inspector::Protocol::Automation::SessionPermissionData>>& out_permissions) = 0;
    virtual void setSessionPermissions(ErrorString&, const JSON::Array& in_permissions) = 0;
protected:
    virtual ~AutomationBackendDispatcherHandler();
};

class AutomationBackendDispatcher final : public SupplementalBackendDispatcher {
public:
    static Ref<AutomationBackendDispatcher> create(BackendDispatcher&, AutomationBackendDispatcherHandler*);
    void dispatch(long requestId, const String& method, Ref<JSON::Object>&& message) override;
private:
    void getBrowsingContexts(long requestId, RefPtr<JSON::Object>&& parameters);
    void getBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void createBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void closeBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void switchToBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void setWindowFrameOfBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void maximizeWindowOfBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void hideWindowOfBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void navigateBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void goBackInBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void goForwardInBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void reloadBrowsingContext(long requestId, RefPtr<JSON::Object>&& parameters);
    void waitForNavigationToComplete(long requestId, RefPtr<JSON::Object>&& parameters);
    void evaluateJavaScriptFunction(long requestId, RefPtr<JSON::Object>&& parameters);
    void performMouseInteraction(long requestId, RefPtr<JSON::Object>&& parameters);
    void performKeyboardInteractions(long requestId, RefPtr<JSON::Object>&& parameters);
    void performInteractionSequence(long requestId, RefPtr<JSON::Object>&& parameters);
    void cancelInteractionSequence(long requestId, RefPtr<JSON::Object>&& parameters);
    void takeScreenshot(long requestId, RefPtr<JSON::Object>&& parameters);
    void resolveChildFrameHandle(long requestId, RefPtr<JSON::Object>&& parameters);
    void resolveParentFrameHandle(long requestId, RefPtr<JSON::Object>&& parameters);
    void computeElementLayout(long requestId, RefPtr<JSON::Object>&& parameters);
    void selectOptionElement(long requestId, RefPtr<JSON::Object>&& parameters);
    void isShowingJavaScriptDialog(long requestId, RefPtr<JSON::Object>&& parameters);
    void dismissCurrentJavaScriptDialog(long requestId, RefPtr<JSON::Object>&& parameters);
    void acceptCurrentJavaScriptDialog(long requestId, RefPtr<JSON::Object>&& parameters);
    void messageOfCurrentJavaScriptDialog(long requestId, RefPtr<JSON::Object>&& parameters);
    void setUserInputForCurrentJavaScriptPrompt(long requestId, RefPtr<JSON::Object>&& parameters);
    void setFilesToSelectForFileUpload(long requestId, RefPtr<JSON::Object>&& parameters);
    void getAllCookies(long requestId, RefPtr<JSON::Object>&& parameters);
    void deleteSingleCookie(long requestId, RefPtr<JSON::Object>&& parameters);
    void addSingleCookie(long requestId, RefPtr<JSON::Object>&& parameters);
    void deleteAllCookies(long requestId, RefPtr<JSON::Object>&& parameters);
    void getSessionPermissions(long requestId, RefPtr<JSON::Object>&& parameters);
    void setSessionPermissions(long requestId, RefPtr<JSON::Object>&& parameters);
private:
    AutomationBackendDispatcher(BackendDispatcher&, AutomationBackendDispatcherHandler*);
    AutomationBackendDispatcherHandler* m_agent { nullptr };
};

} // namespace Inspector
